/*
 *      preferences.h
 *
 *      Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef PREFERENCES_H
#define PREFERENCES_H

#include <string>

#define CONF_PREFIX "/dxim-curses"
#define DXPREFERENCES Preferences::instance()

class Preferences
{
public:
    Preferences();
    Preferences(const Preferences &p);

    void save();
    void load();
    static Preferences &instance();

    //General settings
    bool m_useAway;
    int m_awayTimeout; //in minutes
    bool m_logging;
    std::string m_logPath;
    bool m_logLoadCurrent;
    bool m_receiptsMark;
    //Notification settings
    bool m_notify;
    bool m_notifyAccountConnect;
    bool m_notifyAccountDisconnect;
    bool m_notifyBuddyConnect;
    bool m_notifyBuddyDisconnect;
    bool m_notifyMessage;
    bool m_notifyFiletransfer;
    //Other settings value
    bool m_hideOffline;
    bool m_showStatusmsg;
    bool m_showRosterTree;
    int m_rosterWidth;
    int m_logHeight;
};

#endif // PREFERENCES_H
