/*
 *      aboutdialog.cpp
 *
 *      Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#include "aboutdialog.h"
#include "gettext.h"
#include "dxutils.h"
#include "dxim.h"
#include <curses.h>

AboutDialog::AboutDialog()
: SplitDialog(0, 0, 80, 24, _("About dxim"))
{
    SetColorScheme("generaldialog");
    CppConsUI::ListBox *box = new CppConsUI::ListBox(AUTOSIZE, AUTOSIZE);
    SetContainer(*box);
    CppConsUI::Label *l = new CppConsUI::Label(AUTOSIZE, 1, dxutils::sformat("dxim %s", VERSION).c_str());
    box->AppendWidget(*l);
    l = new CppConsUI::Label(AUTOSIZE, 1, ("(Curses UI)"));
    box->AppendWidget(*l);
    l = new CppConsUI::Label(AUTOSIZE, 1, " ");
    box->AppendWidget(*l);
    l = new CppConsUI::Label(AUTOSIZE, 1, _("Copyright (C) 2012~"));
    box->AppendWidget(*l);
    l = new CppConsUI::Label(AUTOSIZE, 1, "David Vachulka (arch_dvx@users.sourceforge.net)");
    box->AppendWidget(*l);
    l = new CppConsUI::Label(AUTOSIZE, 1, _("and others"));
    box->AppendWidget(*l);
    l = new CppConsUI::Label(AUTOSIZE, 1, " ");
    box->AppendWidget(*l);
    l = new CppConsUI::Label(AUTOSIZE, 1, dxutils::sformat(_("Uses %s"), curses_version()).c_str());
    box->AppendWidget(*l);
    l = new CppConsUI::Label(AUTOSIZE, 1, dxutils::sformat(_("Uses purplemm %s"), DXIM->GetPurplemm()->getPurplemmVersion().c_str()).c_str());
    box->AppendWidget(*l);
    l = new CppConsUI::Label(AUTOSIZE, 1, dxutils::sformat(_("Uses libpurple %s"), DXIM->GetPurplemm()->getLibpurpleVersion().c_str()).c_str());
    box->AppendWidget(*l);
    l = new CppConsUI::Label(AUTOSIZE, 1, " ");
    box->AppendWidget(*l);
    l = new CppConsUI::Label(AUTOSIZE, 1, "https://dxim.dxsolutions.org");
    box->AppendWidget(*l);
    buttons->AppendItem(OK_BUTTON_TEXT, sigc::hide(sigc::mem_fun(this, &AboutDialog::Close)));
}

void AboutDialog::OnScreenResized()
{
    MoveResizeRect(DXIM->GetScreenArea(dxim::CHAT_AREA));
}

