/*
 *      addbuddydialog.h
 *
 *      Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef ADDBUDDYDIALOG_H
#define ADDBUDDYDIALOG_H

#include <cppconsui/SplitDialog.h>
#include <cppconsui/InputDialog.h>
#include <cppconsui/Button.h>
#include <cppconsui/ComboBox.h>
#include <purplemm.h>

class AddBuddyDialog
: public CppConsUI::SplitDialog
{
    public:
        AddBuddyDialog(PURPLE::Account account);
        virtual ~AddBuddyDialog() {}

        // FreeWindow
        virtual void OnScreenResized();
    protected:
    private:
        AddBuddyDialog(const AddBuddyDialog&);
        AddBuddyDialog& operator=(const AddBuddyDialog&);

        PURPLE::Account m_account;
        CppConsUI::Button *m_id, *m_nick;
        CppConsUI::ComboBox *m_groups;

        void OnOk(CppConsUI::Button& activator);
        void OnId(CppConsUI::Button& activator);
        void OnIdResponseHandler(CppConsUI::InputDialog& activator, CppConsUI::AbstractDialog::ResponseType response);
        void OnNick(CppConsUI::Button& activator);
        void OnNickResponseHandler(CppConsUI::InputDialog& activator, CppConsUI::AbstractDialog::ResponseType response);
};

#endif // ADDBUDDYDIALOG_H
