/*
 *      chatjoindialog.h
 *
 *      Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef CHATJOINDIALOG_H
#define CHATJOINDIALOG_H

#include <cppconsui/SplitDialog.h>
#include <cppconsui/InputDialog.h>
#include <cppconsui/Button.h>
#include <cppconsui/ComboBox.h>
#include <cppconsui/CheckBox.h>
#include <purplemm.h>

class ChatJoinDialog
: public CppConsUI::SplitDialog
{
    public:
        ChatJoinDialog(PURPLE::Account account);

        // FreeWindow
        virtual void OnScreenResized();
    protected:
        class IntegerOption
        : public CppConsUI::Button
        {
        public:
            IntegerOption(const char *text, const char *value, int min, int max);
            virtual ~IntegerOption();
        protected:
            int m_min, m_max;

            void OnActivate(CppConsUI::Button& activator);
            void ResponseHandler(CppConsUI::InputDialog& activator, CppConsUI::AbstractDialog::ResponseType response);
        private:
            IntegerOption(const IntegerOption&);
            IntegerOption& operator=(const IntegerOption&);
        };
        
        class StringOption
        : public CppConsUI::Button
        {
        public:
            StringOption(const char *text, const char *value);
            virtual ~StringOption();
        protected:
            void OnActivate(CppConsUI::Button& activator);
            void ResponseHandler(CppConsUI::InputDialog& activator, CppConsUI::AbstractDialog::ResponseType response);
        private:
            StringOption(const StringOption&);
            StringOption& operator=(const StringOption&);
        };
    private:
        ChatJoinDialog(const ChatJoinDialog&);
        ChatJoinDialog& operator=(const ChatJoinDialog&);

        PURPLE::Account m_account;
        std::vector<CppConsUI::Button*> m_fields;

        void CreateWidgets();
        std::vector<PURPLE::Account::ChatEntry> FillChatEntryFields();
        void OnJoin(CppConsUI::Button& activator);
};

#endif // CHATDIALOG_H
