/*
 *      choicerequestdialog.h
 *
 *      Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef CHOICEREQUESTDIALOG_H
#define CHOICEREQUESTDIALOG_H

#include <cppconsui/SplitDialog.h>
#include <cppconsui/InputDialog.h>
#include <cppconsui/Button.h>
#include <purplemm.h>

class ChoiceRequestDialog
: public CppConsUI::SplitDialog
{
    public:
        ChoiceRequestDialog(PURPLE::ChoiceRequest *request);
        virtual ~ChoiceRequestDialog() {}

        // FreeWindow
        virtual void OnScreenResized();
        void OnResponse(CppConsUI::Button& activator, CppConsUI::AbstractDialog::ResponseType response);
    protected:
        class ChoiceOption
        : public CppConsUI::Button
        {
        public:
            ChoiceOption(const char *text, int id);
            virtual ~ChoiceOption();
            
            int GetID() const { return m_id; }
        private:
            ChoiceOption(const ChoiceOption&);
            ChoiceOption& operator=(const ChoiceOption&);
            
            int m_id;
        };
    private:
        ChoiceRequestDialog(const ChoiceRequestDialog&);
        ChoiceRequestDialog& operator=(const ChoiceRequestDialog&);
        
        PURPLE::ChoiceRequest *m_request;
        CppConsUI::ListBox *m_choice;
};

#endif // CHOICEREQUESTDIALOG_H
