/*
 *      filerequestdialog.h
 *
 *      Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef FILEREQUESTDIALOG_H
#define FILEREQUESTDIALOG_H

#include <cppconsui/SplitDialog.h>
#include <cppconsui/InputDialog.h>
#include <cppconsui/Button.h>
#include <purplemm.h>

class FileRequestDialog
: public CppConsUI::SplitDialog
{
    public:
        FileRequestDialog(PURPLE::FileRequest *request);
        virtual ~FileRequestDialog() {}

        // FreeWindow
        virtual void OnScreenResized();
        void OnResponse(CppConsUI::Button& activator, CppConsUI::AbstractDialog::ResponseType response);
    protected:
        class StringOption
        : public CppConsUI::Button
        {
        public:
            StringOption(const char *text, const char *value);
            virtual ~StringOption();
        protected:
            void OnActivate(CppConsUI::Button& activator);
            void ResponseHandler(CppConsUI::InputDialog& activator, CppConsUI::AbstractDialog::ResponseType response);
        private:
            StringOption(const StringOption&);
            StringOption& operator=(const StringOption&);
        };
    private:
        FileRequestDialog(const FileRequestDialog&);
        FileRequestDialog& operator=(const FileRequestDialog&);
        
        PURPLE::FileRequest *m_request;
        CppConsUI::Button *m_folder;
        StringOption *m_file;
        
        void OnFolderActivate(CppConsUI::Button& activator);
        void OnFolderResponseHandler(CppConsUI::InputDialog& activator, CppConsUI::AbstractDialog::ResponseType response);
};

#endif // FILEREQUESTDIALOG_H
