/*
 *      filetranferdialog.h
 *
 *      Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef FILETRANSFERDIALOG_H
#define FILETRANSFERDIALOG_H

#include <cppconsui/Button.h>
#include <cppconsui/CheckBox.h>
#include <cppconsui/SplitDialog.h>
#include <cppconsui/TreeView.h>
#include <purplemm.h>


class FileTransferDialog
: public CppConsUI::SplitDialog
{
public:
    FileTransferDialog();
    virtual ~FileTransferDialog() {}

    // FreeWindow
    virtual void OnScreenResized();
    void NewFileTransfer(PURPLE::FileTransfer *ft);
protected:
    class FileTransferItem
    : public CppConsUI::TreeView::ToggleCollapseButton
    {
    friend class FileTransferDialog;
    public:
        FileTransferItem(PURPLE::FileTransfer *ft);
        virtual ~FileTransferItem() {}

        void SetRefNode(CppConsUI::TreeView::NodeReference n, CppConsUI::TreeView *tree);
    protected:
        void OnCancelToggle(CppConsUI::CheckBox& activator, bool new_state);
    private:
        FileTransferItem(const FileTransferItem&);
        FileTransferItem& operator=(const FileTransferItem&);
        
        PURPLE::FileTransfer *m_ft;
        CppConsUI::TreeView::NodeReference m_ref;
        CppConsUI::Button *m_account, *m_direction, *m_path, *m_progress, *m_remaining;
        CppConsUI::CheckBox *m_cancel;
        
        //purplemm
        void OnFileTransferFinished(PURPLE::FileTransfer *ft);
        void OnFileTransferStarted(PURPLE::FileTransfer *ft);
        void OnFileTransferProgress(PURPLE::FileTransfer *ft);
        void OnFileTransferCanceled(PURPLE::FileTransfer *ft);
    };
private:
    FileTransferDialog(const FileTransferDialog&);
    FileTransferDialog& operator=(const FileTransferDialog&);
    
    CppConsUI::TreeView *m_tree;

    void OnOk(CppConsUI::Button& activator);
    //purplemm
    void OnFileTransferStarted(PURPLE::FileTransfer *ft);
};

#endif // FILETRANSFERDIALOG_H

