/*
 * Copyright (C) 2011-2012 by CenterIM developers
 * Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef FOOTER_H
#define FOOTER_H

#include "dxim.h"
#include <cppconsui/FreeWindow.h>
#include <cppconsui/Label.h>

#define FOOTER (Footer::Instance())

// the bottom area of the screen containing context sensitive help
class Footer
: public CppConsUI::FreeWindow
{
public:
    static Footer *Instance();
    // FreeWindow
    virtual void OnScreenResized();
    void SetText(const char *fmt, ...) _attribute((format(printf, 2, 3)));
private:
    friend class dxim;

    typedef std::vector<std::string> Values;

    CppConsUI::Label *m_label;
    Values m_values;
    static Footer *m_instance;

    Footer();
    Footer(const Footer&);
    Footer &operator=(const Footer&);
    virtual ~Footer() {}

    static void Init();
    static void Finalize();
    void UpdateText();
};

#endif // FOOTER_H
