/*
 * joinchatmenu.cpp
 *
 * Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "joinchatmenu.h"
#include "gettext.h"
#include "dxim.h"
#include "dxutils.h"
#include "chatjoindialog.h"

JoinChatMenu::JoinChatMenu()
: MenuWindow(0, 0, AUTOSIZE, AUTOSIZE)
{
    SetTitle(_("Select account"));
    SetColorScheme("generalmenu");
    std::vector<PURPLE::Account> accounts = DXIM->GetPurplemm()->getConnectedAccountsList();
    for(guint i=0; i<accounts.size(); i++)
    {
        if(accounts[i].supportsChats()) AppendItem(dxutils::sformat("%s [%s]", accounts[i].getUsername().c_str(), accounts[i].getProtocol().getName().c_str()).c_str(),
                   sigc::bind(sigc::mem_fun(this, &JoinChatMenu::OpenPopup), accounts[i]));
    }
}

void JoinChatMenu::OnScreenResized()
{
    CppConsUI::Rect chat = DXIM->GetScreenArea(dxim::CHAT_AREA);
    Move(chat.x, chat.y);
}

void JoinChatMenu::OpenPopup(CppConsUI::Button& /*activator*/, PURPLE::Account account)
{
    ChatJoinDialog *dialog = new ChatJoinDialog(account);
    dialog->Show();
    Close();
}


