/*
 * mainmenu.h
 *
 * Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef MAINMENU_H
#define	MAINMENU_H

#include <cppconsui/MenuWindow.h>

class MainMenu
: public CppConsUI::MenuWindow
{
public:
    MainMenu();
    virtual ~MainMenu() {}

    // FreeWindow
    virtual void OnScreenResized();
private:
    MainMenu(const MainMenu&);
    MainMenu& operator=(const MainMenu&);

    void OpenAccountsDialog(CppConsUI::Button& activator);
    void OpenNewBuddyMenu(CppConsUI::Button& activator);
    void OpenNewChatMenu(CppConsUI::Button& activator);
    void OpenNewGroupMenu(CppConsUI::Button& activator);
    void OpenStatusMenu(CppConsUI::Button& activator);
    void OpenNewImMenu(CppConsUI::Button& activator);
    void OpenJoinChatMenu(CppConsUI::Button& activator);
    void OpenPluginsDialog(CppConsUI::Button& activator);
    void OpenOptionDialog(CppConsUI::Button& activator);
    void ClearCurrent(CppConsUI::Button& activator);
    void ClearAll(CppConsUI::Button& activator);
    void About(CppConsUI::Button& activator);
    void Keybindings(CppConsUI::Button& activator);
};

#endif	/* MAINMENU_H */

