/*
 *      msgdialog.cpp
 *
 *      Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#include "msgdialog.h"
#include "gettext.h"
#include "dxim.h"
#include <utilsmm.h>

MsgDialog::MsgDialog(const std::string &id, const std::string &title)
: SplitDialog(0, 0, 80, 24, title.c_str()), m_id(id)
{
    SetColorScheme("generaldialog");
    CppConsUI::ListBox *box = new CppConsUI::ListBox(AUTOSIZE, AUTOSIZE);
    SetContainer(*box);
    m_view = new CppConsUI::TextView(AUTOSIZE, AUTOSIZE, true);
    m_view->SetScrollBar(true);
    box->AppendWidget(*m_view);
    buttons->AppendItem(OK_BUTTON_TEXT, sigc::hide(sigc::mem_fun(this, &MsgDialog::Close)));
}

void MsgDialog::OnScreenResized()
{
    MoveResizeRect(DXIM->GetScreenArea(dxim::CHAT_AREA));
}

void MsgDialog::Clear()
{
    m_view->Clear();
}

void MsgDialog::WriteText(const std::string& text)
{
    m_view->Append(PURPLE::stripHtml(text).c_str());
}


