/*
 *      msgdialog.h
 *
 *      Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef MSGDIALOG_H
#define MSGDIALOG_H

#include <cppconsui/SplitDialog.h>
#include <cppconsui/TextView.h>

class MsgDialog
: public CppConsUI::SplitDialog
{
    public:
        MsgDialog(const std::string &id, const std::string &title);
        virtual ~MsgDialog() {}

        // FreeWindow
        virtual void OnScreenResized();
        void Clear();
        void WriteText(const std::string &text);
        std::string GetID() const { return m_id; }
    private:
        MsgDialog(const MsgDialog&);
        MsgDialog& operator=(const MsgDialog&);

        CppConsUI::TextView *m_view;
        std::string m_id;
};

#endif // MSGDIALOG_H
