/*
 * newimmenu.h
 *
 * Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef NEWIMMENU_H
#define NEWIMMENU_H

#include <cppconsui/MenuWindow.h>
#include <cppconsui/SplitDialog.h>
#include <cppconsui/Button.h>
#include <cppconsui/InputDialog.h>
#include <purplemm.h>

class NewImMenu
: public CppConsUI::MenuWindow
{
public:
    NewImMenu();
    virtual ~NewImMenu() {}

    // FreeWindow
    virtual void OnScreenResized();
private:
    class PopupDialog
    : public CppConsUI::SplitDialog
    {
        public:
            PopupDialog(PURPLE::Account account);
            virtual ~PopupDialog() {}
        private:
            PURPLE::Account m_account;
            CppConsUI::Button *m_with;

            PopupDialog(const PopupDialog&);
            PopupDialog& operator=(const PopupDialog&);

            void OnWith(CppConsUI::Button& activator);
            void OnWithResponseHandler(CppConsUI::InputDialog& activator, CppConsUI::AbstractDialog::ResponseType response);
            void OnIM(CppConsUI::Button& activator);
    };

    NewImMenu(const NewImMenu&);
    NewImMenu& operator=(const NewImMenu&);

    void OpenPopup(CppConsUI::Button& activator, PURPLE::Account account);
};

#endif  /* NEWIMMENU_H */

