/*
 *      pluginsdialog.h
 *
 *      Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef PLUGINSDIALOG_H
#define PLUGINSDIALOG_H

#include <cppconsui/Button.h>
#include <cppconsui/ListBox.h>
#include <cppconsui/SplitDialog.h>
#include <cppconsui/AbstractDialog.h>
#include <purplemm.h>

class PluginsDialog
: public CppConsUI::SplitDialog
{
public:
    PluginsDialog();
    virtual ~PluginsDialog() {}

    // FreeWindow
    virtual void OnScreenResized();
protected:
    class PluginItem
    : public CppConsUI::Button
    {
    public:
        PluginItem(PURPLE::Plugin plugin, CppConsUI::SplitDialog *parent);
        virtual ~PluginItem();
    protected:
        PURPLE::Plugin m_plugin;
        CppConsUI::SplitDialog *m_parent;

        void OnActivate(CppConsUI::Button& activator);
    private:
        PluginItem(const PluginItem&);
        PluginItem& operator=(const PluginItem&);
    };

    void AddPlugin(PURPLE::Plugin plugin);
private:
    PluginsDialog(const PluginsDialog&);
    PluginsDialog& operator=(const PluginsDialog&);

    CppConsUI::ListBox *m_box;

    void OnDone(CppConsUI::Button& activator);
};

#endif // PLUGINSDIALOG_H

