/*
 *      statusdialog.h
 *
 *      Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef STATUSDIALOG_H
#define STATUSDIALOG_H

#include <cppconsui/SplitDialog.h>
#include <cppconsui/InputDialog.h>
#include <cppconsui/Button.h>
#include <cppconsui/ComboBox.h>
#include <purplemm.h>

class StatusDialog
: public CppConsUI::SplitDialog
{
    public:
        StatusDialog(PURPLE::Account account);
        virtual ~StatusDialog() {}

        // FreeWindow
        virtual void OnScreenResized();
    protected:
    private:
        StatusDialog(const StatusDialog&);
        StatusDialog& operator=(const StatusDialog&);

        PURPLE::Account m_account;
        CppConsUI::Button *m_msg;
        CppConsUI::ComboBox *m_statuses;

        void OnOk(CppConsUI::Button& activator);
        void OnMsg(CppConsUI::Button& activator);
        void OnMsgResponseHandler(CppConsUI::InputDialog& activator, CppConsUI::AbstractDialog::ResponseType response);
};

#endif // STATUSDIALOG_H
