/*
 * statusmenu.h
 *
 * Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef STATUSMENU_H
#define STATUSMENU_H

#include <cppconsui/MenuWindow.h>
#include <cppconsui/InputDialog.h>
#include <purplemm.h>

class StatusMenu
: public CppConsUI::MenuWindow
{
public:
    StatusMenu();
    virtual ~StatusMenu() {}
    
    // FreeWindow
    virtual void OnScreenResized();
private:
    StatusMenu(const StatusMenu&);
    StatusMenu& operator=(const StatusMenu&);

    void Reconnect(CppConsUI::Button& activator);
    void SetStatus(CppConsUI::Button& activator, PurpleStatusPrimitive status);
    void SetStatusMsg(CppConsUI::Button& activator);
    void StatusMsgResponseHandler(CppConsUI::InputDialog& activator, CppConsUI::AbstractDialog::ResponseType response);
};

#endif  /* STATUSMENU_H */

