%define is_mandrake %(test -e /etc/mandrake-release && echo 1 || echo 0)
%define is_suse %(test -e /etc/SuSE-release && echo 1 || echo 0)
%define is_fedora %(test -e /etc/fedora-release && echo 1 || echo 0)

Name:       dxim
Version:    1.00.svn
Summary: dxim - multiprotocol instant messenger
Release: 1
License: GPL
Group: Productivity/Networking/Instant Messenger
Source: %{name}-%{version}.tar.gz
Packager: David Vachulka <arch_dvx@users.sourceforge.net>
BuildRoot: %{_tmppath}/%{name}-buildroot
BuildRequires: cmake libpurple-devel >= 2.8.0

%description
dxim - multiprotocol instant messenger.

%package data
Summary: dxim - multiprotocol instant messenger, data files
BuildRequires: gettext

%description data
dxim - multiprotocol instant messenger, data files.

%package fox
Summary: dxim - multiprotocol instant messenger with FOX toolkit GUI
Requires: dxim-data
%if %is_mandrake
BuildRequires: libfox1.6-devel libpng-devel >= 1.2 libxscrnsaver1-devel
%else
BuildRequires: fox-devel >= 1.6 libpng-devel >= 1.2 libXScrnSaver-devel
%endif

%description fox
dxim - multiprotocol instant messenger with FOX toolkit GUI.

%package gtkmm
Summary: dxim - multiprotocol instant messenger with Gtk GUI
Requires: dxim-data
%if %is_mandrake
BuildRequires: libgtkmm3.0-devel libxscrnsaver1-devel
%endif
%if %is_suse
BuildRequires: gtkmm3-devel libXScrnSaver-devel
%else
BuildRequires: gtkmm30-devel libXScrnSaver-devel
%endif

%description gtkmm
dxim - multiprotocol instant messenger with Gtk GUI.

%package qt
Summary: dxim - multiprotocol instant messenger with Qt GUI
Requires: dxim-data
%if %is_mandrake
BuildRequires: libqt5-qtbase-devel libqt5multimedia-devel libxscrnsaver1-devel
%endif
%if %is_fedora
BuildRequires: qt5-qtbase-devel qt5-qtmultimedia-devel libXScrnSaver-devel
%else
BuildRequires: libqt5-qtbase-devel libqt5-qtmultimedia-devel libXScrnSaver-devel
%endif

%description qt
dxim - multiprotocol instant messenger with Qt GUI.

%package curses
Summary: dxim - multiprotocol instant messenger with curses UI
Requires: dxim-data
BuildRequires: ncurses-devel

%description curses
dxim - multiprotocol instant messenger with curses UI.

%global debug_package %{nil}

%prep
%setup -q

%build
mkdir build
pushd build
cmake \
    -DCMAKE_INSTALL_PREFIX=%{_prefix} \
    ..
make
popd #build

%install
pushd build
%make_install
popd #build

%clean
rm -rf %{buildroot}

%files data
%defattr(-,root,root)
%{_datadir}/icons/*
%{_datadir}/dxim/*
%{_datadir}/locale/*

%files fox
%defattr(-,root,root)
%{_bindir}/dxim-fox
%{_datadir}/applications/dxim-fox.desktop

%files gtkmm
%defattr(-,root,root)
%{_bindir}/dxim-gtkmm
%{_datadir}/applications/dxim-gtkmm.desktop

%files qt
%defattr(-,root,root)
%{_bindir}/dxim-qt
%{_datadir}/applications/dxim-qt.desktop

%files curses
%defattr(-,root,root)
%{_bindir}/dxim-curses
%{_datadir}/applications/dxim-curses.desktop

