/*
 *      FXTrayApp.h
 *
 *      Copyright (c) 2008, Hendrik Rittich
 *      Copyright (C) 2006-2011 by Sander Jansen
 *      Copyright 2012 David Vachulka <david@konstrukce-cad.com>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef FX_TRAY_APP
#define FX_TRAY_APP

#include "fx.h"
#include "FXArray.h"

namespace FX {
    
#ifndef WIN32
enum {
  SEL_EMBED_NOTIFY = SEL_LAST,
  SEL_EMBED_MODAL_ON,
  SEL_EMBED_MODAL_OFF
  };
#endif

class FXTrayIcon;

class FXTrayApp : public FXApp
{
    FXDECLARE(FXTrayApp)
    friend class FXTrayIcon;
public:
    FXTrayApp(const FXString& name="Application",
        const FXString& vendor="FoxDefault");

    void create();
#ifndef WIN32
    void registerIcon(FXTrayIcon* ic);
    void unregisterIcon();
#endif
protected:
#ifdef WIN32
    long dispatchEvent(FXID hwnd, unsigned int iMsg, unsigned int wParam,long lParam);
#else
    FXID mXembed;
    FXID mXsystemtray;
    FXID mXmanager;

    bool dispatchEvent(FXRawEvent& ev);
#endif
private:
#ifdef WIN32
    unsigned int mTaskbarRestartId;
#else
    FXTrayIcon *mIcon;
#endif
};

}

#endif
