/*
 *      defs.h
 *
 *      Copyright 2010 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef DEFS_H_
#define DEFS_H_

#include <fx.h>
#include <fxkeys.h>
#include <string>
#include <map>
#include <fstream>
#include <purplemm.h>
#ifndef DXTEXT_H
#include "dxtext.h"
#endif

#define TAB (FXString)"\t"
#define FOREACH(t, v, it) \
    for(t::iterator it = v.begin(); it < v.end(); it++)

enum dximID {
    dxim_TABS = FXMainWindow::ID_LAST,
    dxim_ROSTER,
    dxim_ACCOUNTS,
    dxim_ADDBUDDY,
    dxim_ADDCHAT,
    dxim_ADDGROUP,
    dxim_IM,
    dxim_CHAT,
    dxim_LOG,
    dxim_QUIT,
    dxim_RECONNECT,
    dxim_AVAILABLE,
    dxim_INVISIBLE,
    dxim_AWAY,
    dxim_BUSY,
    dxim_OFFLINE,
    dxim_STATUSMSG,
    dxim_CLOSETAB,
    dxim_CLEAR,
    dxim_CLEARALL,
    dxim_HIDEROSTER,
    dxim_HIDECHATROSTER,
    dxim_SHOWAVATARS,
    dxim_HIDEOFFLINE,
    dxim_SHOWSTATUSMSG,
    dxim_PLUGINS,
    dxim_OPTIONS,
    dxim_ABOUT,
    dxim_TRAY_CLICKED,
    dxim_NEXTTAB,
    dxim_NEXTUNREAD,
    dxim_SELECTTAB,
    dxim_AWAYTIMEOUT,
    dxim_POPUPIM,
    dxim_POPUPCHAT,
    dxim_POPUPSENDFILE,
    dxim_POPUPINFO,
    dxim_POPUPBUDDYCB,
    dxim_POPUPACCOUNTCB,
    dxim_POPUPACCOUNTSTATUS,
    dxim_POPUPACCOUNTIM,
    dxim_POPUPACCOUNTCHAT,
    dxim_POPUPADDBUDDY,
    dxim_POPUPADDGROUP,
    dxim_POPUPADDCHAT,
    dxim_POPUPRENAMEBUDDY,
    dxim_POPUPMOVEBUDDY,
    dxim_POPUPREMOVEBUDDY,
    dxim_POPUPUPDATECHAT,
    dxim_POPUPREMOVECHAT,
    dxim_POPUPENABLEACCOUNT,
    dxim_POPUPALIASACCOUNT,
    dxim_POPUPRECONNECTACCOUNT,
    dxim_POPUPCONFIGACCOUNT,
    dxim_POPUPHISTORY,
    dxim_TRANSFERS,
    dxim_NOTIFYHIDE,
    dxim_RESTART,
    dxPipe_READ,
    dxPipe_PIPE,
    AboutDialog_LINK,
    ConfigDialog_ACCEPT,
    ConfigDialog_CANCEL,
    ConfigDialog_STATUSICONS,
    ConfigDialog_ADDSTATUSICONS,
    ConfigDialog_DELETESTATUSICONS,
    ConfigDialog_ROLEICONS,
    ConfigDialog_ADDROLEICONS,
    ConfigDialog_DELETEROLEICONS,
    ConfigDialog_TRAY,
    ConfigDialog_LOG,
    ConfigDialog_LOGPATH,
    ConfigDialog_NICK,
    ConfigDialog_IMCOLORS,
    ConfigDialog_COLORS,
    ConfigDialog_TABCOLORS,
    ConfigDialog_THEME,
    ConfigDialog_FONT,
    ConfigDialog_IMFONT,
    ConfigDialog_TABPOS,
    ConfigDialog_NOTIFYPOS,
    ConfigDialog_SOUNDS,
    ConfigDialog_SOUNDCONNECT,
    ConfigDialog_SOUNDDISCONNECT,
    ConfigDialog_SOUNDMESSAGE,
    ConfigDialog_PLAYCONNECT,
    ConfigDialog_PLAYDISCONNECT,
    ConfigDialog_PLAYMESSAGE,
    ConfigDialog_SELECTCONNECT,
    ConfigDialog_SELECTDISCONNECT,
    ConfigDialog_SELECTMESSAGE,
    ConfigDialog_NOTIFY,
    ConfigDialog_SHOWNOTIFY,
    ConfigDialog_USESMILEYS,
    ConfigDialog_ADDSMILEY,
    ConfigDialog_MODIFYSMILEY,
    ConfigDialog_SMILEY,
    ConfigDialog_DELETESMILEY,
    ConfigDialog_IMPORTSMILEY,
    ConfigDialog_EXPORTSMILEY,
    ConfigDialog_AWAY,
    ConfigDialog_USEAWAY,
    ConfigDialog_TABS,
    ConfigDialog_MODIFYBINDINGS,
    ConfigDialog_REFRESHBINDINGS,
    ConfigDialog_RAISEWINDOW,
    KeybindingsDialog_CANCEL,
    KeybindingsDialog_SAVECLOSE,
    KeybindingsDialog_LIST,
    SmileyDialog_ACCEPT,
    SmileyDialog_CANCEL,
    SmileyDialog_PATH,
    MsgTabItem_MSGCANCEL,
    MsgTabItem_MSGOK,
    dxTabItem_TEXT,
    dxTabItem_PTIME,
    dxTabItem_SHOWLOG,
    ImTabItem_COMMANDLINE,
    ImTabItem_COMPOSETIMEOUT,
    ImTabItem_HIGHLIGHT,
    ChatTabItem_COMMANDLINE,
    ChatTabItem_TOPIC,
    ChatTabItem_USERS,
    ChatTabItem_POPUPIM,
    ChatTabItem_POPUPINFO,
    ChatTabItem_POPUPIGNORE,
    ChatTabItem_HIGHLIGHT,
    TextTabItem_OK,
    LogThread_LIST,
    Purple_EVENT,
    ChatJoinDialog_LIST,
    ChatJoinDialog_JOIN,
    ChatJoinDialog_ID,
    ChatDialog_OK,
    IMDialog_ID,
    IMDialog_BUDDIES,
    IMDialog_WITH,
    InputRequestDialog_OK,
    InputRequestDialog_CANCEL,
    ChoiceRequestDialog_OK,
    ChoiceRequestDialog_CANCEL,
    AccountDialog_ADD,
    AccountDialog_MODIFY,
    AccountDialog_DELETE,
    AccountDialog_TABLE,
    AccountDialog_ENABLE,
    AccountEditor_SAVE,
    AccountEditor_CANCEL,
    AccountEditor_TABS,
    AccountEditor_ICON,
    AccountEditor_REMOVE,
    PluginDialog_MODIFY,
    PluginDialog_ENABLE,
    PluginDialog_TABLE,
    PluginDialog_HOMEPAGE,
    PluginEditor_SAVE,
    PluginEditor_CANCEL,
    RoomListDialog_JOIN,
    RoomListDialog_CANCEL,
    RoomListDialog_TABLE,
    RoomListDialog_SEARCH,
    FTDialog_CLOSE,
    FTDialog_CLEAR,
    FTDialog_CANCELED,
    FTDialog_TABLE,
    FTDialog_POPUPCANCEL,
    FTDialog_CANCEL,
    LogViewer_ADD,
    LogViewer_CLOSE,
    LogViewer_TREE,
    LogViewer_RESET,
    LogViewer_ALL,
    LogViewer_ACCOUNT,
    LogViewer_CONVERSATION,
    LogViewer_FILE,
    LogViewer_SEARCH,
    LogViewer_SEARCHNEXT,
    LogViewer_PACK,
    LogViewer_UNPACK,
    LogViewer_DELETEITEM,
    LogViewer_TEXT,
    LogViewer_OPENLINK,
    LogViewer_COPYLINK,
    LogViewer_STIMEOUT, //timeout for status change
    FieldsRequestDialog_OK,
    FieldsRequestDialog_CANCEL,
    ActionRequestDialog_BUTTON //!!!Have to be last for FXMAPFUNCS
};

struct ColorTheme {
    const FXchar* name;
    FXColor base;
    FXColor border;
    FXColor back;
    FXColor fore;
    FXColor selback;
    FXColor selfore;
    FXColor tipback;
    FXColor tipfore;
    FXColor menuback;
    FXColor menufore;
    FXColor notifyback;
    FXColor notifyfore;
    FXColor shadow;
    FXColor hilite;
};

struct ImColor {
    FXColor text;
    FXColor back;
    FXColor user;
    FXColor action;
    FXColor error;
    FXColor hilight;
    FXColor link;
    FXColor mymsg;
    FXColor history;
};

enum MsgType {
    MSGINFORMATION,
    MSGWARNING,
    MSGERROR,
    MSGNEWMAIL
};

struct MsgInfo {
    MsgType type;
    FXString title;
    FXString text;
    FXString okText;
    FXString cancelText;
    FXString url; //needed for show new gmail in browser
    FXTime time; //time of adding
};

typedef FXArray<FXString> dxStringArray;
typedef FXArray<dxHiliteStyle> dxHiliteArray;
typedef FXArray<PURPLE::FileTransfer*> dxFileTransferArray;
typedef std::map<FXString,FXString> dxStringMap;
typedef std::pair<FXString,FXString> dxStringPair;
typedef std::map<FXString, FXString>::iterator dxStringIt;

#endif /* DEFS_H_ */
