/*
 *      chatdialog.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef CHATDIALOG_H
#define CHATDIALOG_H

#include "fxext.h"
#include "dxutils.h"

typedef FXArray<FXWindow*> dxEntryArray;

class ChatDialog : public FXDialogBox
{
    FXDECLARE(ChatDialog)
public:
    //for create new PURPLE::Chat
    ChatDialog(FXMainWindow *owner, PURPLE::Account account);
    //for modify PURPLE::Chat
    ChatDialog(FXMainWindow *owner, PURPLE::Chat chat);
    virtual ~ChatDialog();

    long onOK(FXObject*,FXSelector,void*);
private:
    ChatDialog() {}
    ChatDialog(const ChatDialog&);

    FXVerticalFrame *m_contents;
    FXMatrix *m_matrix;
    PURPLE::Account m_account;
    PURPLE::Chat m_chat;
    dxEntryArray m_chatEntryFields;
    FXCheckButton *m_autoJoin;
    FXTextField *m_alias;
    FXComboBox *m_groups;
    bool m_modifing;

    void createWidgets();
    std::vector<PURPLE::Account::ChatEntry> fillChatEntryFields();
};

#endif  /* CHATDIALOG_H */

