/*
 *      chatjoindialog.h
 *
 *      Copyright 2011 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef CHATJOINDIALOG_H
#define CHATJOINDIALOG_H

#include "fxext.h"
#include "dxutils.h"

typedef FXArray<FXWindow*> dxEntryArray;
typedef FXArray<FXLabel*> dxLabelArray;

class ChatJoinDialog : public FXDialogBox
{
    FXDECLARE(ChatJoinDialog)
public:
    ChatJoinDialog(FXMainWindow *owner, PURPLE::Purple *purple);
    ChatJoinDialog(FXMainWindow *owner, PURPLE::Account account);
    virtual ~ChatJoinDialog();

    long onRoomList(FXObject*,FXSelector,void*);
    long onJoinRoom(FXObject*,FXSelector,void*);
    long onAccount(FXObject*,FXSelector,void*);

    void newRoomList(PURPLE::RoomList *rlist);
    void setRoom(FXString room);
private:
    ChatJoinDialog() {}
    ChatJoinDialog(const ChatJoinDialog&);

    FXVerticalFrame *m_contents;
    FXMatrix *m_matrix;
    FXListBox *m_ids;
    dxEXButton *m_getRoomList;
    std::vector<PURPLE::Account> m_accounts;
    dxEntryArray m_chatEntryFields;
    dxLabelArray m_labels;

    void createControls();
    void createChatEntryFields(std::vector<PURPLE::Account::ChatEntry> fields, bool create=false);
    FXString createLabel(std::string label);
    std::vector<PURPLE::Account::ChatEntry> fillChatEntryFields();
};

#endif  /* CHATJOINDIALOG_H */

