/*
 *      configdialog.h
 *
 *      Copyright 2010 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */


#ifndef CONFIGDIALOG_H
#define CONFIGDIALOG_H

#include "defs.h"
#include "fxext.h"
#include "tabitems/dxtabbook.h"
#ifndef PREFERENCES_H
#include "preferences.h"
#endif

const ColorTheme ColorThemes[]={
//|--------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------|
//|        Name        |        Base      |       Border     |       Back       |      Fore        |      Selback     |      Selfore     |      Tipback     |     Tipfore      |      Menuback    |      Menufore    |      Notifyback  |      Notifyfore  |
//|--------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------|
  {"FOX"               ,FXRGB(212,208,200),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB( 10, 36,106),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB( 10, 36,106),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Gnome"             ,FXRGB(214,215,214),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(  0,  0,128),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(  0,  0,128),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Atlas Green"       ,FXRGB(175,180,159),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(111,122, 99),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(111,122, 99),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"BeOS"              ,FXRGB(217,217,217),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(168,168,168),FXRGB(  0,  0,  0),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(168,168,168),FXRGB(  0,  0,  0),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Blue Slate"        ,FXRGB(239,239,239),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(103,141,178),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(103,141,178),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Black and White"   ,FXRGB(  8,  8,  8),FXRGB( 77, 77, 77),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,255),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(  0,  0,255),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"CDE"               ,FXRGB(156,153,156),FXRGB(  0,  0,  0),FXRGB(131,129,131),FXRGB(255,255,255),FXRGB( 49, 97,131),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB( 49, 97,131),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Digital CDE"       ,FXRGB( 74,121,131),FXRGB(  0,  0,  0),FXRGB( 55, 77, 78),FXRGB(255,255,255),FXRGB( 82,102,115),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB( 82,102,115),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Dark Blue"         ,FXRGB( 66,103,148),FXRGB(  0,  0,  0),FXRGB(  0, 42, 78),FXRGB(255,255,255),FXRGB( 92,179,255),FXRGB(  0,  0,  0),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB( 92,179,255),FXRGB(  0,  0,  0),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Desert FOX"        ,FXRGB(214,205,187),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(128,  0,  0),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(128,  0,  0),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"EveX"              ,FXRGB(230,222,220),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB( 10, 95,137),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB( 10, 95,137),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Galaxy"            ,FXRGB(239,239,239),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(103,141,178),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(103,141,178),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"iMac"              ,FXRGB(205,206,205),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(  0,  0,128),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(  0,  0,128),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"KDE 1"             ,FXRGB(192,192,192),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(  0,  0,128),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(  0,  0,128),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"KDE 2"             ,FXRGB(220,220,220),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB( 10, 95,137),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB( 10, 95,137),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"KDE 3"             ,FXRGB(238,238,230),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(255,221,118),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(255,221,118),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Keramik"           ,FXRGB(234,233,232),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(169,209,255),FXRGB(  0,  0,  0),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(169,209,255),FXRGB(  0,  0,  0),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Keramik Emerald"   ,FXRGB(238,238,230),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(134,204,134),FXRGB(  0,  0,  0),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(134,204,134),FXRGB(  0,  0,  0),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Keramik White"     ,FXRGB(239,239,239),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(103,141,178),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(103,141,178),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Mandrake"          ,FXRGB(230,231,230),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB( 33, 68,156),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB( 33, 68,156),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Media Peach"       ,FXRGB(239,239,239),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(103,141,178),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(103,141,178),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Next"              ,FXRGB(168,168,168),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Obsidian Coast"    ,FXRGB( 48, 47, 47),FXRGB(  0,  0,  0),FXRGB( 32, 31, 31),FXRGB(224,223,220),FXRGB( 24, 72,128),FXRGB(255,255,255),FXRGB( 16, 48, 80),FXRGB(196,209,224),FXRGB( 24, 72,128),FXRGB(255,255,255),FXRGB( 16, 48, 80),FXRGB(196,209,224)},
  {"Pale Gray"         ,FXRGB(214,214,214),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Plastik"           ,FXRGB(239,239,239),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(103,141,178),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(103,141,178),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Pumpkin"           ,FXRGB(238,216,174),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(205,133, 63),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(205,133, 63),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Redmond 95"        ,FXRGB(195,195,195),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(  0,  0,128),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(  0,  0,128),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Redmond 2000"      ,FXRGB(212,208,200),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(  0, 36,104),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(  0, 36,104),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Redmond XP"        ,FXRGB(238,238,230),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB( 74,121,205),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB( 74,121,205),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Solaris"           ,FXRGB(174,178,195),FXRGB(  0,  0,  0),FXRGB(147,151,165),FXRGB(  0,  0,  0),FXRGB(113,139,165),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(113,139,165),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Storm"             ,FXRGB(192,192,192),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(139,  0,139),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(139,  0,139),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Sea Sky"           ,FXRGB(165,178,198),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB( 49,101,156),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB( 49,101,156),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Wonton Soup"       ,FXRGB( 71, 76, 86),FXRGB(  0,  0,  0),FXRGB( 58, 62, 70),FXRGB(182,193,208),FXRGB(117,133,153),FXRGB(209,225,244),FXRGB(182,193,208),FXRGB( 42, 44, 48),FXRGB(117,133,153),FXRGB(209,225,244),FXRGB(182,193,208),FXRGB( 42, 44, 48)},
};

const FXint numThemes=ARRAYNUMBER(ColorThemes);

class ConfigDialog: public FXDialogBox
{
    FXDECLARE(ConfigDialog)
    public:
        ConfigDialog(FXMainWindow *owner);
        virtual ~ConfigDialog();

        long onColor(FXObject*,FXSelector,void*);
        long onAccept(FXObject*,FXSelector,void*);
        long onCancel(FXObject*,FXSelector,void*);
        long onKeyPress(FXObject*,FXSelector,void*);
        long onStatusIconsChanged(FXObject*,FXSelector,void*);
        long onAddStatusIcons(FXObject*,FXSelector,void*);
        long onDeleteStatusIcons(FXObject*,FXSelector,void*);
        long onRoleIconsChanged(FXObject*,FXSelector,void*);
        long onAddRoleIcons(FXObject*,FXSelector,void*);
        long onDeleteRoleIcons(FXObject*,FXSelector,void*);
        long onLogChanged(FXObject*,FXSelector,void*);
        long onNickCharChanged(FXObject*,FXSelector,void*);
        long onPathSelect(FXObject*,FXSelector,void*);
        long onTheme(FXObject*,FXSelector,void*);
        long onThemeColorChanged(FXObject*,FXSelector,void*);
        long onTabColorChanged(FXObject*,FXSelector,void*);
        long onFont(FXObject*,FXSelector,void*);
        long onImFont(FXObject*,FXSelector,void*);
        long onTray(FXObject*,FXSelector,void*);
        long onTabPosition(FXObject*,FXSelector,void*);
        long onNotifyPosition(FXObject*,FXSelector,void*);
        long onSounds(FXObject*,FXSelector,void*);
        long onSoundConnect(FXObject*,FXSelector,void*);
        long onSoundDisconnect(FXObject*,FXSelector,void*);
        long onSoundMessage(FXObject*,FXSelector,void*);
        long onPlay(FXObject*,FXSelector,void*);
        long onSelectPath(FXObject*,FXSelector,void*);
        long onNotify(FXObject*,FXSelector,void*);
        long onShowNotify(FXObject*,FXSelector,void*);
        long onUseSmileys(FXObject*,FXSelector,void*);
        long onAddSmiley(FXObject*,FXSelector,void*);
        long onModifySmiley(FXObject*,FXSelector,void*);
        long onDeleteSmiley(FXObject*,FXSelector,void*);
        long onImportSmiley(FXObject*,FXSelector,void*);
        long onExportSmiley(FXObject*,FXSelector,void*);
        long onUseAway(FXObject*,FXSelector,void*);
        long onMouseWheel(FXObject*,FXSelector,void*);
        long onModifyBindings(FXObject*,FXSelector,void*);
        long onRefreshBindings(FXObject*,FXSelector,void*);
        long onRaiseWindow(FXObject*,FXSelector,void*);

    private:
        ConfigDialog() {}
        ConfigDialog(const ConfigDialog&);

        Preferences m_preferences;
        dxTabBook *m_tabbook;
        FXList *m_statusIcons;
        FXList *m_roleIcons;
        FXList *m_smileys;
        dxEXButton *m_addStatusTheme;
        dxEXButton *m_deleteStatusTheme;
        dxEXButton *m_addRoleTheme;
        dxEXButton *m_deleteRoleTheme;
        dxEXButton *m_selectPath;
        dxEXButton *m_addSmiley;
        dxEXButton *m_modifySmiley;
        dxEXButton *m_deleteSmiley;
        dxEXButton *m_importSmiley;
        dxEXButton *m_exportSmiley;
        dxEXButton *m_iconAway;
        dxEXButton *m_iconIdle;
        dxEXButton *m_iconDnd;
        dxEXButton *m_iconInvisible;
        dxEXButton *m_iconOffline;
        dxEXButton *m_iconOnline;
        dxEXButton *m_iconFounder;
        dxEXButton *m_iconHalfop;
        dxEXButton *m_iconNormal;
        dxEXButton *m_iconOp;
        dxEXButton *m_iconVoice;
        dxEXButton *m_fontButton;
        dxEXButton *m_imfontButton;
        FXCheckButton *m_closeToTrayButton;
        FXCheckButton *m_checkConnect;
        FXCheckButton *m_checkDisconnect;
        FXCheckButton *m_checkMessage;
        FXCheckButton *m_minToTrayButton;
        FXCheckButton *m_checkNotifyBuddyConnect;
        FXCheckButton *m_checkNotifyBuddyDisconnect;
        FXCheckButton *m_checkNotifyMessage;
        FXCheckButton *m_checkNotifyAccountConnect;
        FXCheckButton *m_checkNotifyAccountDisconnect;
        FXCheckButton *m_checkNotifyFiletransfer;
        FXCheckButton *m_checkNotifyMessageTray;
        FXCheckButton *m_logLoadCurrent;
        FXTextField *m_textTest;
        FXTextField *m_nickCharField;
        FXToolBar *m_iconsStatusBar;
        FXToolBar *m_iconsRoleBar;
        FXSpinner *m_awaySpinner;
        FXDataTarget m_targetIMColorText;
        FXDataTarget m_targetIMColorBack;
        FXDataTarget m_targetIMColorUser;
        FXDataTarget m_targetIMColorAction;
        FXDataTarget m_targetIMColorError;
        FXDataTarget m_targetIMColorHilight;
        FXDataTarget m_targetIMColorLink;
        FXDataTarget m_targetIMColorMymsg;
        FXDataTarget m_targetIMColorHistory;
        FXDataTarget m_targetTray;
        FXDataTarget m_targetLogging;
        FXDataTarget m_targetLogLoadCurrent;
        FXHiliteStyle m_textStyle[7];
        FXText *m_text;
        ColorTheme m_themeCurrent;
        FXListBox *m_themes;
        FXDataTarget m_targetThemeBack;
        FXDataTarget m_targetThemeBase;
        FXDataTarget m_targetThemeBorder;
        FXDataTarget m_targetThemeFore;
        FXDataTarget m_targetThemeMenuback;
        FXDataTarget m_targetThemeMenufore;
        FXDataTarget m_targetThemeSelback;
        FXDataTarget m_targetThemeSelfore;
        FXDataTarget m_targetThemeTipback;
        FXDataTarget m_targetThemeTipfore;
        FXDataTarget m_targetSameCmd;
        FXDataTarget m_targetSameList;
        FXDataTarget m_targetColoredNick;
        FXDataTarget m_targetCloseToTray;
        FXDataTarget m_targetLogPath;
        FXDataTarget m_targetSound;
        FXDataTarget m_targetSoundConnect;
        FXDataTarget m_targetSoundDisconnect;
        FXDataTarget m_targetSoundMessage;
        FXDataTarget m_targetNotify;
        FXDataTarget m_targetNotifyBuddyConnect;
        FXDataTarget m_targetNotifyBuddyDisconnect;
        FXDataTarget m_targetNotifyMessage;
        FXDataTarget m_targetRaiseWindow;
        FXDataTarget m_targetNotifyMessageTray;
        FXDataTarget m_targetOneInstance;
        FXDataTarget m_targetNotifyAccountConnect;
        FXDataTarget m_targetNotifyAccountDisconnect;
        FXDataTarget m_targetNotifyFiletransfer;
        FXDataTarget m_targetPathConnect;
        FXDataTarget m_targetPathDisconnect;
        FXDataTarget m_targetPathMessage;
        FXDataTarget m_targetUseSmileys;
        FXDataTarget m_targetAwayTimeout, m_targetUseAway;
        FXDataTarget m_targetMinToTray;
        FXDataTarget m_targetUnreadColor;
        FXDataTarget m_targetHighlightColor;
        FXDataTarget m_targetTrayColor;
        FXDataTarget m_targetShowRosterTree;
        FXDataTarget m_targetReceiptsMark;
        dxEXButton *m_selectConnect;
        dxEXButton *m_selectDisconnect;
        dxEXButton *m_selectMessage;
        dxEXButton *m_playConnect;
        dxEXButton *m_playDisconnect;
        dxEXButton *m_playMessage;
        FXLabel *m_labelSelected;
        FXLabel *m_labelNocurrent;
        FXLabel *m_labelTip;
        FXLabel *m_label;
        FXVerticalFrame *m_vframe2;
        FXVerticalFrame *m_menuFrame;
        FXLabel *m_menuLabels[3];
        FXHorizontalFrame *m_textFrame1;
        FXHorizontalFrame *m_textFrame2;
        FXHorizontalFrame *m_textFrame3;
        FXHorizontalFrame *m_tabFrame;
        FXGroupBox *m_menuGroup;
        FXSeparator *m_sep1;
        FXSeparator *m_sep2;
        FXFont *m_font;
        FXFont *m_imFont;
        FXListBox *m_listTabs;
        FXbool m_showImportwarning;
        dxTabBook *m_tabs;
        dxEXTabItem *m_tab;
        dxEXTabItem *m_unread;
        dxEXTabItem *m_highlight;
        FXVerticalFrame *m_tabframe1;
        FXVerticalFrame *m_tabframe2;
        FXVerticalFrame *m_tabframe3;
        FXLabel *m_tabLabel1;
        FXLabel *m_tabLabel2;
        FXLabel *m_tabLabel3;
        FXDataTarget m_targetThemeNotifyback;
        FXDataTarget m_targetThemeNotifyfore;
        FXLabel *m_labelNotify;
        FXListBox *m_listNotifyPos;

        void fillStatusIcons();
        void fillRoleIcons();
        void fillThemes();
        void fillSmileys();
        void updateStatusIcons();
        void updateRoleIcons();
        void updateColors();
        void updateFont();
        void updateImFont();
        void updateTabPosition();
        FXbool themeStatusExist(const FXString &ckdTheme);
        FXbool themeRoleExist(const FXString &ckdTheme);
        FXbool smileyExist(const FXString &ckdSmiley);
        void createImtextTab(dxTabBook *tabbook);
        void createGeneralTab(dxTabBook *tabbook);
        void createSmileysTab(dxTabBook *tabbook);
        void createNotificationTab(dxTabBook *tabbook);
        void createLookTab(dxTabBook *tabbook);
        void createIconsTab(dxTabBook *tabbook);
        void createKeybindingsTab(dxTabBook *tabbook);
};

class SmileyDialog: public FXDialogBox
{
    FXDECLARE(SmileyDialog)
public:
    SmileyDialog(FXWindow *owner, FXString title, FXString smiley, FXString path);
    virtual ~SmileyDialog();

    long onAccept(FXObject*,FXSelector,void*);
    long onCancel(FXObject*,FXSelector,void*);
    long onPath(FXObject*,FXSelector,void*);

    FXString getSmiley() { return m_smileyText->getText(); }
    FXString getPath() { return m_pathText->getText(); }
    FXbool iconExist();
    FXIcon* getIcon() const { return m_previewLabel->getIcon(); }
private:
    SmileyDialog() {}
    SmileyDialog(const SmileyDialog&);

    FXTextField *m_smileyText;
    FXTextField *m_pathText;
    dxEXButton *m_pathButton;
    FXLabel *m_previewLabel;
};

#endif /* CONFIGDIALOG_H */
