/*
 *      fieldsrequestdialog.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef FIELDSREQUESTDIALOG_H
#define	FIELDSREQUESTDIALOG_H

#include "fxext.h"
#include "dxutils.h"

typedef FXArray<FXWindow*> dxFieldsArray;

class FieldsRequestDialog : public FXDialogBox {
    FXDECLARE(FieldsRequestDialog)
public:
    FieldsRequestDialog(FXMainWindow *owner, PURPLE::FieldsRequest *request);
    virtual ~FieldsRequestDialog();

    long onOk(FXObject *, FXSelector, void *);
    long onCancel(FXObject *, FXSelector, void *);
private:
    FieldsRequestDialog() {}
    FieldsRequestDialog(const FieldsRequestDialog&);

    PURPLE::FieldsRequest *m_request;
    dxFieldsArray m_fields;

    void createFields(FXVerticalFrame *contents);
    void fillFields();
};

#endif	/* FIELDSREQUESTDIALOG_H */

