/*
 *      ftdialog.h
 *
 *      Copyright 2011 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */


#ifndef FTDIALOG_H
#define FTDIALOG_H

#include "defs.h"
#include "fxext.h"

class FTDialog: public FXTopWindow
{
    FXDECLARE(FTDialog)
    public:
        FTDialog(FXApp *app);
        virtual ~FTDialog();

        virtual void create();
        
        long onClose(FXObject*,FXSelector,void*);
        long onKeyPress(FXObject*,FXSelector,void*);
        long onClear(FXObject*,FXSelector,void*);
        long onCanceled(FXObject*,FXSelector,void*);
        long onRightClick(FXObject*,FXSelector,void*);
        long onPopupCancel(FXObject*,FXSelector,void*);
        long onTableChanged(FXObject*,FXSelector,void*);
        
        void newFT(PURPLE::FileTransfer *ft);
        void updateFT(PURPLE::FileTransfer *ft);
    private:
        FTDialog() {}
        FTDialog(const FTDialog&);

        FXVerticalFrame *m_contents, *m_tableframe;
        FXMatrix *m_matrix;
        FXHorizontalFrame *m_buttonframe;
        dxEXButton *m_buttonClose, *m_buttonClear, *m_buttonCanceled;
        FXTable *m_table;
        FXLabel *m_path, *m_account, *m_protocol, *m_buddy, *m_direction;
        FXGroupBox *m_group;
        FXint m_indexOnRight;
        dxFileTransferArray m_transfers;

        void updateTable();
};

#endif // FTDIALOG_H
