/*
 *      imdialog.h
 *
 *      Copyright 2011 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef IMDIALOG_H
#define IMDIALOG_H

#include "fxext.h"
#include "dxutils.h"

class IMDialog : public FXDialogBox
{
    FXDECLARE(IMDialog)
public:
    IMDialog(FXMainWindow *owner, PURPLE::Purple *purple);
    IMDialog(FXMainWindow *owner, PURPLE::Account account);
    virtual ~IMDialog();

    long onKeyPress(FXObject*,FXSelector,void*);
    long onBuddies(FXObject*,FXSelector,void*);
    long onIDs(FXObject*,FXSelector,void*);

    PURPLE::Account getAccount();
    FXString getIM() { return m_with->getText(); }
private:
    IMDialog() {}
    IMDialog(const IMDialog&);

    FXVerticalFrame *m_contents;
    FXMatrix *m_matrix;
    FXListBox *m_ids;
    FXTextField *m_with;
    FXList *m_buddiesList;
    std::vector<PURPLE::Account> m_accounts;
    std::vector<PURPLE::Buddy> m_buddies;

    void close();
};

#endif  /* IMDIALOG_H */

