/*
 *      inputrequestdialog.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef INPUTREQUESTDIALOG_H
#define INPUTREQUESTDIALOG_H

#include "fxext.h"

class InputRequestDialog : public FXDialogBox
{
    FXDECLARE(InputRequestDialog)
public:
    InputRequestDialog(FXMainWindow *owner, PURPLE::InputRequest *request);
    virtual ~InputRequestDialog();

    long onOK(FXObject*,FXSelector,void*);
    long onCancel(FXObject*,FXSelector,void*);
private:
    InputRequestDialog() {}
    InputRequestDialog(const InputRequestDialog&);

    FXVerticalFrame *m_contents;
    FXTextField *m_input;
    PURPLE::InputRequest *m_request;
};

#endif  /* INPUTREQUESTDIALOG_H */

