/*
 *      plugindialog.h
 *
 *      Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */


#ifndef PLUGINDIALOG_H
#define PLUGINDIALOG_H

#include "defs.h"
#include "fxext.h"

class PluginDialog: public FXDialogBox
{
    FXDECLARE(PluginDialog)
    public:
        PluginDialog(FXMainWindow *owner, std::vector<PURPLE::Plugin> plugins);
        virtual ~PluginDialog();

        long onModify(FXObject*,FXSelector,void*);
        long onKeyPress(FXObject*,FXSelector,void*);
        long onTableChanged(FXObject*,FXSelector,void*);
        long onEnable(FXObject*,FXSelector,void*);
        long onLink(FXObject*,FXSelector,void*);
        long onLinkMotion(FXObject*,FXSelector,void*);
    private:
        PluginDialog() {}
        PluginDialog(const PluginDialog&);

        FXVerticalFrame *m_contents;
        FXTable *m_table;
        dxEXButton *m_buttonModify, *m_buttonEnable;
        FXText *m_description, *m_summary;
        FXLabel *m_version, *m_author, *m_path;
        FXButton *m_homepage;
        std::vector<PURPLE::Plugin> m_plugins;
        FXGroupBox *m_group;

        void updateTable();
        void updateDetails();
        void updateButtons();
};

#endif // PLUGINDIALOG_H
