/*
 *      plugineditor.h
 *
 *      Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef PLUGINEDITOR_H
#define PLUGINEDITOR_H

#include "defs.h"
#include "fxext.h"

typedef FXArray<FXWindow*> dxOptionsArray;

class PluginEditor : public FXDialogBox
{
    FXDECLARE(PluginEditor);
private:
    PURPLE::Plugin m_plugin; //use for modifying
    PURPLE::Plugin::Options m_options;
    dxEXButton *m_buttonOK, *m_buttonCancel;
    dxOptionsArray m_optionsFields;

    PluginEditor() { }
    PluginEditor(const PluginEditor &);
    void initializeEditor();
    void saveOptions();
    int getIntListValue(std::map<std::string, int> map, std::string key);
public:
    /* Constructor for modifying plugin */
    PluginEditor(FXDialogBox *, PURPLE::Plugin);
    virtual ~PluginEditor();

    /* Handles modifying & creating account */
    long onSave(FXObject *, FXSelector, void *);
    /* Handles cancelation of modifying or creating account */
    long onCancel(FXObject *, FXSelector, void *);
    /* Handles keypress actions */
    long onKeyPress(FXObject *, FXSelector, void *);
};

#endif
