/*
 *      roomlistdialog.h
 *
 *      Copyright 2011 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef ROOMLISTDIALOG_H
#define	ROOMLISTDIALOG_H

#include "fxext.h"
#include "dxutils.h"

class ChatJoinDialog;

class RoomListDialog: public FXDialogBox
{
    FXDECLARE(RoomListDialog)
public:
    RoomListDialog(ChatJoinDialog *owner, PURPLE::RoomList *list);
    virtual ~RoomListDialog();

    void createColumns(std::vector<std::string> columns);
    void addRoom(std::vector<std::string> values);
    void listFinished();
    PURPLE::RoomList *getRoomList() { return m_list; }

    long onJoin(FXObject*,FXSelector,void*);
    long onCancel(FXObject*,FXSelector,void*);
    long onTable(FXObject*,FXSelector,void*);
    long onKeyPress(FXObject*,FXSelector,void*);
    long onSearch(FXObject*,FXSelector,void*);
private:
    RoomListDialog() {}
    RoomListDialog(const RoomListDialog& orig);

    FXVerticalFrame *m_contents, *m_tableframe;
    FXHorizontalFrame *m_buttonframe, *m_searchframe;
    FXIconList *m_table;
    dxEXButton *m_buttonJoin, *m_buttonCancel;
    ChatJoinDialog *m_owner;
    PURPLE::RoomList *m_list;
    dxStringArray m_rooms;
    FXTextField *m_search;
};

#endif	/* ROOMLISTDIALOG_H */

