/*
 *      icons.cpp
 *
 *      Copyright 2010 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#include <fx.h>
#include <FXPNGIcon.h>

#include "icons.h"
#include "dxutils.h"

FXIcon *ICO_AWAY, *ICO_INVISIBLE, *ICO_DND, *ICO_OFFLINE, *ICO_ONLINE, *ICO_IDLE, *ICO_BIGICON, *ICO_SMALLICON, *ICO_NEWM;
FXIcon *ICO_PLAY, *ICO_CLOSEFOLDER, *ICO_OPENFOLDER, *ICO_FILE, *ICO_ABOUTICON;
FXIcon *ICO_IM, *ICO_IMNEWMSG, *ICO_IMCOMPOSE, *ICO_IMOFF, *ICO_CHAT, *ICO_CHATNEWMSG, *ICO_ROSTERCHAT;
FXIcon *ICO_SSL, *ICO_BIGINFORMATION, *ICO_BIGWARNING, *ICO_BIGERROR, *ICO_BIGQUESTION;
FXIcon *ICO_CLEAR, *ICO_SELECTALL, *ICO_COPY, *ICO_FIND, *ICO_REFRESH, *ICO_KEYBINDINGS;
FXIcon *ICO_DOWN, *ICO_UP, *ICO_CANCEL, *ICO_FINISH, *ICO_TRANSFER, *ICO_INFORMATION, *ICO_WARNING, *ICO_QUESTION, *ICO_EMAIL;
FXIcon *ICO_ROSTEROPENED, *ICO_ROSTERCLOSED, *ICO_LOGS;
FXIcon *ICO_ROSTERAWAY, *ICO_ROSTERDND, *ICO_ROSTERIDLE, *ICO_ROSTERINVISIBLE, *ICO_ROSTEROFFLINE, *ICO_ROSTERONLINE, *ICO_ROSTERCONNECTING;
FXIcon *ICO_XMPP, *ICO_WLM;
FXIcon *ICO_IRC, *ICO_ICQ, *ICO_AIM, *ICO_BONJOUR, *ICO_GG, *ICO_NOVELL, *ICO_MYSPACE;
FXIcon *ICO_SILC, *ICO_MEANWHILE, *ICO_SIMPLE, *ICO_YAHOO, *ICO_SKYPE, *ICO_MXIT, *ICO_ZEPHYR, *ICO_TELEGRAM, *ICO_SLACK;
FXIcon *ICO_CHRFOUNDER, *ICO_CHRHALFOP, *ICO_CHRNORMAL, *ICO_CHROP, *ICO_CHRVOICE;
FXColor menuColor, textBackColor;

/* created by reswrap from file empty.png */
const unsigned char empty[]={
  0x2f,0x2a,0x20,0x47,0x65,0x6e,0x65,0x72,0x61,0x74,0x65,0x64,0x20,0x62,0x79,0x20,
  0x72,0x65,0x73,0x77,0x72,0x61,0x70,0x20,0x76,0x65,0x72,0x73,0x69,0x6f,0x6e,0x20,
  0x34,0x2e,0x30,0x2e,0x30,0x20,0x2a,0x2f,0x0a,0x0a
};


/* created by reswrap from file dximsmall.png */
const unsigned char small_dxim[]={
  0x89,0x50,0x4e,0x47,0x0d,0x0a,0x1a,0x0a,0x00,0x00,0x00,0x0d,0x49,0x48,0x44,0x52,
  0x00,0x00,0x00,0x10,0x00,0x00,0x00,0x10,0x08,0x06,0x00,0x00,0x00,0x1f,0xf3,0xff,
  0x61,0x00,0x00,0x00,0x04,0x73,0x42,0x49,0x54,0x08,0x08,0x08,0x08,0x7c,0x08,0x64,
  0x88,0x00,0x00,0x00,0x09,0x70,0x48,0x59,0x73,0x00,0x00,0x00,0xdd,0x00,0x00,0x00,
  0xdd,0x01,0x70,0x53,0xa2,0x07,0x00,0x00,0x00,0x19,0x74,0x45,0x58,0x74,0x53,0x6f,
  0x66,0x74,0x77,0x61,0x72,0x65,0x00,0x77,0x77,0x77,0x2e,0x69,0x6e,0x6b,0x73,0x63,
  0x61,0x70,0x65,0x2e,0x6f,0x72,0x67,0x9b,0xee,0x3c,0x1a,0x00,0x00,0x02,0x86,0x49,
  0x44,0x41,0x54,0x38,0x8d,0x75,0x92,0x4b,0x4f,0x53,0x41,0x14,0xc7,0xff,0x67,0xe6,
  0xde,0x4b,0x0b,0x2d,0x8f,0xd2,0x07,0x01,0x81,0x94,0x86,0x08,0x3e,0x6a,0xc1,0x88,
  0xa9,0x12,0x25,0x71,0xe3,0xc6,0x8d,0xd1,0x6f,0xe0,0xd2,0x9d,0xf1,0x5b,0xb8,0x32,
  0x2e,0x35,0x7e,0x01,0xa2,0x89,0xba,0x70,0xe9,0x42,0x54,0xdc,0x20,0x1a,0x04,0x5b,
  0x0a,0x56,0x50,0x14,0xb4,0xb4,0x94,0xa4,0xf7,0x35,0x73,0x5c,0x20,0x05,0x84,0xce,
  0x6a,0x92,0x73,0xe6,0x37,0xbf,0xf3,0x20,0x66,0x46,0xa3,0x73,0xed,0xfa,0x8d,0xbb,
  0x04,0x38,0xcf,0x9e,0x4c,0xde,0x6f,0x94,0x23,0x1a,0x05,0xc6,0xc6,0x2e,0xf7,0xa6,
  0x87,0x07,0xdb,0x92,0xc9,0xde,0x78,0x2a,0x95,0x6a,0x6b,0x94,0x47,0xfb,0x0d,0x46,
  0x47,0x47,0x63,0xd1,0xee,0xee,0x6c,0x7f,0x5f,0xcf,0xc0,0x40,0x5f,0x2a,0x79,0xf1,
  0xc2,0x79,0x28,0xa5,0xfd,0xd7,0x6f,0xde,0x21,0x9f,0xcf,0x17,0xd7,0x36,0x7e,0x15,
  0x97,0x16,0x16,0x5e,0x15,0x0a,0x85,0xca,0x21,0x40,0x3a,0x9d,0x3e,0x9d,0xcd,0x66,
  0xaf,0x26,0x12,0xd1,0xcd,0x78,0x3c,0x71,0x33,0x16,0x4f,0xb4,0x86,0x5b,0xc3,0x35,
  0xad,0x35,0x6f,0x55,0xb7,0xda,0xca,0xe5,0xca,0xca,0xd7,0xc2,0xf2,0xf3,0xcd,0xed,
  0xcd,0xce,0xf7,0x53,0x1f,0x27,0x67,0x67,0xa7,0x97,0x01,0xc0,0xd8,0x25,0xb5,0x46,
  0xa3,0xc3,0x44,0x94,0xfb,0xbc,0xf8,0xe3,0xd1,0xdc,0xcc,0xac,0xe5,0x19,0x92,0x4f,
  0x0c,0x1f,0x0f,0xf8,0x9e,0xcf,0x5f,0xf2,0x05,0x57,0xba,0x6a,0x90,0xc2,0xb1,0x33,
  0x7d,0x5d,0x2d,0x77,0x42,0x9d,0x2d,0x69,0x00,0x07,0x01,0x01,0xd3,0x24,0xdb,0xb6,
  0x7d,0x82,0x68,0xbb,0xd5,0x5f,0x30,0x9e,0xae,0xf7,0x21,0x97,0x5b,0xdc,0x09,0x32,
  0x9a,0x08,0x0c,0x41,0xe4,0x78,0x9e,0x56,0x86,0x94,0xf5,0x77,0xf5,0x0b,0x00,0xd2,
  0xda,0x63,0xb0,0x81,0x66,0x43,0x61,0xd5,0xb6,0x30,0x11,0xff,0x8d,0x2e,0xd3,0x81,
  0x45,0x2e,0x9a,0xd9,0xc6,0xe3,0x52,0x02,0x5a,0xbb,0x07,0xc6,0xb6,0x37,0x05,0x25,
  0xd9,0x75,0x15,0x5f,0x0d,0xcf,0x4b,0x0b,0x1e,0xb4,0xd6,0x18,0xef,0xf8,0x09,0xdb,
  0xd7,0xe8,0x0f,0x54,0xd1,0x2c,0x3d,0x68,0x66,0x76,0x5d,0x8f,0xa5,0x32,0x8e,0x00,
  0x00,0x70,0x1c,0x47,0xbd,0x28,0x0f,0xa9,0x92,0x6b,0x62,0x22,0xb2,0x8e,0x88,0xac,
  0xe1,0xe5,0x7a,0x04,0x1b,0x8e,0x01,0x82,0x06,0x33,0x43,0x29,0x28,0xad,0x55,0xdd,
  0x62,0x7f,0x09,0x70,0x5d,0x97,0x4d,0x83,0x41,0xca,0x47,0x2a,0x58,0xc6,0x7c,0x39,
  0x08,0x5f,0x69,0xd8,0x9e,0x86,0x04,0x43,0x2b,0x8d,0x5a,0xcd,0x66,0x66,0xa6,0x23,
  0x00,0x4c,0xb6,0xed,0x28,0x19,0x64,0x7a,0xb0,0x94,0x84,0x92,0x12,0xb1,0x68,0x04,
  0xa1,0x56,0x85,0x87,0xdf,0x00,0xe1,0x32,0x64,0x07,0x0c,0xc7,0x71,0xd4,0xbe,0x1e,
  0xee,0x01,0xca,0xd5,0xad,0xea,0xd9,0xcc,0xd0,0x95,0x40,0x93,0x59,0x91,0xd1,0x9e,
  0x16,0x56,0x35,0x69,0x35,0x59,0x92,0xb4,0xe2,0x58,0xb0,0x5d,0x09,0x23,0xa8,0x3d,
  0x33,0xe4,0x57,0xb6,0xc4,0xf8,0xea,0x5a,0xee,0xed,0xa1,0x45,0x02,0x80,0x4c,0x26,
  0x73,0xd2,0x0c,0x86,0x6e,0x93,0x60,0x5d,0x2e,0x55,0xa6,0x42,0x1d,0xed,0x29,0x4b,
  0x88,0x70,0xe9,0x4f,0x69,0xa6,0x33,0xd6,0x7e,0x89,0x85,0x90,0x95,0xb2,0x73,0x6f,
  0xfe,0xc3,0x74,0xee,0x90,0x01,0x11,0x09,0x00,0x2b,0xa7,0x46,0x46,0xe6,0x85,0x46,
  0x3a,0xbf,0x30,0xb7,0x1d,0xef,0xee,0x26,0xcb,0x34,0x69,0xb5,0x58,0xac,0x86,0xc2,
  0xe7,0x0c,0xa5,0xfd,0x4f,0x0b,0xb3,0x33,0xdf,0x89,0x88,0xf8,0xdf,0xcf,0x75,0x03,
  0x22,0x32,0x01,0x44,0x01,0x0c,0x02,0x38,0x06,0x20,0x2c,0x84,0x68,0xde,0xd9,0x0f,
  0xbd,0x0d,0xa0,0x02,0x60,0x05,0x40,0x1e,0x40,0x89,0x99,0xd5,0xff,0x00,0x02,0x60,
  0x02,0x08,0x00,0xb0,0x00,0x48,0x00,0xbb,0xdd,0xd6,0x00,0x14,0x00,0x17,0x80,0x0d,
  0xc0,0xdf,0x35,0xf8,0x0b,0xfc,0x02,0x39,0x09,0x33,0xbd,0x03,0xd5,0x00,0x00,0x00,
  0x00,0x49,0x45,0x4e,0x44,0xae,0x42,0x60,0x82
};

/* created by reswrap from file dxim.png */
const unsigned char big_dxim[]={
  0x89,0x50,0x4e,0x47,0x0d,0x0a,0x1a,0x0a,0x00,0x00,0x00,0x0d,0x49,0x48,0x44,0x52,
  0x00,0x00,0x00,0x10,0x00,0x00,0x00,0x10,0x08,0x06,0x00,0x00,0x00,0x1f,0xf3,0xff,
  0x61,0x00,0x00,0x00,0x04,0x73,0x42,0x49,0x54,0x08,0x08,0x08,0x08,0x7c,0x08,0x64,
  0x88,0x00,0x00,0x00,0x09,0x70,0x48,0x59,0x73,0x00,0x00,0x00,0xdd,0x00,0x00,0x00,
  0xdd,0x01,0x70,0x53,0xa2,0x07,0x00,0x00,0x00,0x19,0x74,0x45,0x58,0x74,0x53,0x6f,
  0x66,0x74,0x77,0x61,0x72,0x65,0x00,0x77,0x77,0x77,0x2e,0x69,0x6e,0x6b,0x73,0x63,
  0x61,0x70,0x65,0x2e,0x6f,0x72,0x67,0x9b,0xee,0x3c,0x1a,0x00,0x00,0x02,0x86,0x49,
  0x44,0x41,0x54,0x38,0x8d,0x75,0x92,0x4b,0x4f,0x53,0x41,0x14,0xc7,0xff,0x67,0xe6,
  0xde,0x4b,0x0b,0x2d,0x8f,0xd2,0x07,0x01,0x81,0x94,0x86,0x08,0x3e,0x6a,0xc1,0x88,
  0xa9,0x12,0x25,0x71,0xe3,0xc6,0x8d,0xd1,0x6f,0xe0,0xd2,0x9d,0xf1,0x5b,0xb8,0x32,
  0x2e,0x35,0x7e,0x01,0xa2,0x89,0xba,0x70,0xe9,0x42,0x54,0xdc,0x20,0x1a,0x04,0x5b,
  0x0a,0x56,0x50,0x14,0xb4,0xb4,0x94,0xa4,0xf7,0x35,0x73,0x5c,0x20,0x05,0x84,0xce,
  0x6a,0x92,0x73,0xe6,0x37,0xbf,0xf3,0x20,0x66,0x46,0xa3,0x73,0xed,0xfa,0x8d,0xbb,
  0x04,0x38,0xcf,0x9e,0x4c,0xde,0x6f,0x94,0x23,0x1a,0x05,0xc6,0xc6,0x2e,0xf7,0xa6,
  0x87,0x07,0xdb,0x92,0xc9,0xde,0x78,0x2a,0x95,0x6a,0x6b,0x94,0x47,0xfb,0x0d,0x46,
  0x47,0x47,0x63,0xd1,0xee,0xee,0x6c,0x7f,0x5f,0xcf,0xc0,0x40,0x5f,0x2a,0x79,0xf1,
  0xc2,0x79,0x28,0xa5,0xfd,0xd7,0x6f,0xde,0x21,0x9f,0xcf,0x17,0xd7,0x36,0x7e,0x15,
  0x97,0x16,0x16,0x5e,0x15,0x0a,0x85,0xca,0x21,0x40,0x3a,0x9d,0x3e,0x9d,0xcd,0x66,
  0xaf,0x26,0x12,0xd1,0xcd,0x78,0x3c,0x71,0x33,0x16,0x4f,0xb4,0x86,0x5b,0xc3,0x35,
  0xad,0x35,0x6f,0x55,0xb7,0xda,0xca,0xe5,0xca,0xca,0xd7,0xc2,0xf2,0xf3,0xcd,0xed,
  0xcd,0xce,0xf7,0x53,0x1f,0x27,0x67,0x67,0xa7,0x97,0x01,0xc0,0xd8,0x25,0xb5,0x46,
  0xa3,0xc3,0x44,0x94,0xfb,0xbc,0xf8,0xe3,0xd1,0xdc,0xcc,0xac,0xe5,0x19,0x92,0x4f,
  0x0c,0x1f,0x0f,0xf8,0x9e,0xcf,0x5f,0xf2,0x05,0x57,0xba,0x6a,0x90,0xc2,0xb1,0x33,
  0x7d,0x5d,0x2d,0x77,0x42,0x9d,0x2d,0x69,0x00,0x07,0x01,0x01,0xd3,0x24,0xdb,0xb6,
  0x7d,0x82,0x68,0xbb,0xd5,0x5f,0x30,0x9e,0xae,0xf7,0x21,0x97,0x5b,0xdc,0x09,0x32,
  0x9a,0x08,0x0c,0x41,0xe4,0x78,0x9e,0x56,0x86,0x94,0xf5,0x77,0xf5,0x0b,0x00,0xd2,
  0xda,0x63,0xb0,0x81,0x66,0x43,0x61,0xd5,0xb6,0x30,0x11,0xff,0x8d,0x2e,0xd3,0x81,
  0x45,0x2e,0x9a,0xd9,0xc6,0xe3,0x52,0x02,0x5a,0xbb,0x07,0xc6,0xb6,0x37,0x05,0x25,
  0xd9,0x75,0x15,0x5f,0x0d,0xcf,0x4b,0x0b,0x1e,0xb4,0xd6,0x18,0xef,0xf8,0x09,0xdb,
  0xd7,0xe8,0x0f,0x54,0xd1,0x2c,0x3d,0x68,0x66,0x76,0x5d,0x8f,0xa5,0x32,0x8e,0x00,
  0x00,0x70,0x1c,0x47,0xbd,0x28,0x0f,0xa9,0x92,0x6b,0x62,0x22,0xb2,0x8e,0x88,0xac,
  0xe1,0xe5,0x7a,0x04,0x1b,0x8e,0x01,0x82,0x06,0x33,0x43,0x29,0x28,0xad,0x55,0xdd,
  0x62,0x7f,0x09,0x70,0x5d,0x97,0x4d,0x83,0x41,0xca,0x47,0x2a,0x58,0xc6,0x7c,0x39,
  0x08,0x5f,0x69,0xd8,0x9e,0x86,0x04,0x43,0x2b,0x8d,0x5a,0xcd,0x66,0x66,0xa6,0x23,
  0x00,0x4c,0xb6,0xed,0x28,0x19,0x64,0x7a,0xb0,0x94,0x84,0x92,0x12,0xb1,0x68,0x04,
  0xa1,0x56,0x85,0x87,0xdf,0x00,0xe1,0x32,0x64,0x07,0x0c,0xc7,0x71,0xd4,0xbe,0x1e,
  0xee,0x01,0xca,0xd5,0xad,0xea,0xd9,0xcc,0xd0,0x95,0x40,0x93,0x59,0x91,0xd1,0x9e,
  0x16,0x56,0x35,0x69,0x35,0x59,0x92,0xb4,0xe2,0x58,0xb0,0x5d,0x09,0x23,0xa8,0x3d,
  0x33,0xe4,0x57,0xb6,0xc4,0xf8,0xea,0x5a,0xee,0xed,0xa1,0x45,0x02,0x80,0x4c,0x26,
  0x73,0xd2,0x0c,0x86,0x6e,0x93,0x60,0x5d,0x2e,0x55,0xa6,0x42,0x1d,0xed,0x29,0x4b,
  0x88,0x70,0xe9,0x4f,0x69,0xa6,0x33,0xd6,0x7e,0x89,0x85,0x90,0x95,0xb2,0x73,0x6f,
  0xfe,0xc3,0x74,0xee,0x90,0x01,0x11,0x09,0x00,0x2b,0xa7,0x46,0x46,0xe6,0x85,0x46,
  0x3a,0xbf,0x30,0xb7,0x1d,0xef,0xee,0x26,0xcb,0x34,0x69,0xb5,0x58,0xac,0x86,0xc2,
  0xe7,0x0c,0xa5,0xfd,0x4f,0x0b,0xb3,0x33,0xdf,0x89,0x88,0xf8,0xdf,0xcf,0x75,0x03,
  0x22,0x32,0x01,0x44,0x01,0x0c,0x02,0x38,0x06,0x20,0x2c,0x84,0x68,0xde,0xd9,0x0f,
  0xbd,0x0d,0xa0,0x02,0x60,0x05,0x40,0x1e,0x40,0x89,0x99,0xd5,0xff,0x00,0x02,0x60,
  0x02,0x08,0x00,0xb0,0x00,0x48,0x00,0xbb,0xdd,0xd6,0x00,0x14,0x00,0x17,0x80,0x0d,
  0xc0,0xdf,0x35,0xf8,0x0b,0xfc,0x02,0x39,0x09,0x33,0xbd,0x03,0xd5,0x00,0x00,0x00,
  0x00,0x49,0x45,0x4e,0x44,0xae,0x42,0x60,0x82
};

FXIcon* makeIcon(FXApp *app, const FXString path, const FXString name)
{
    FXIcon *icon = NULL;
    FXString file = FXPath::search(path, name);
    if(!file.empty())
    {
        icon = new FXPNGIcon(app);
        if(icon)
        {
            FXFileStream stream;
            if(stream.open(file, FXStreamLoad))
            {
                icon->loadPixels(stream);
                icon->create();
                stream.close();
                return icon;
            }
        }
        delete icon;
    }
    else
    {
        icon = new FXPNGIcon(app, name == "dxim.png" ? small_dxim : empty);
        icon->create();
        return icon;
    }
    return NULL;
}

FXIcon* makeIcon(FXApp *app, const FXString path, const FXString name, const FXbool menu)
{
    FXIcon *icon = NULL;
    FXString file = FXPath::search(path, name);
    if(!file.empty())
    {
        icon = new FXPNGIcon(app);
        if(icon)
        {
            FXFileStream stream;
            if(stream.open(file, FXStreamLoad))
            {
                icon->loadPixels(stream);
                icon->blend(menu ? menuColor : textBackColor);
                icon->create();
                stream.close();
                return icon;
            }
        }
        delete icon;
    }
    else
    {
        if(name=="dximsmall.png") icon = new FXPNGIcon(app, small_dxim);
        else if(name=="dxim.png") icon = new FXPNGIcon(app, big_dxim);
        else icon = new FXPNGIcon(app, empty);
        icon->create();
        return icon;
    }
    return NULL;
}

FXIcon* makeIcon(FXApp* app, const FXString& path, FXint size, FXColor color)
{
    FXIconSource iconsource(app);
    FXIcon *icon = NULL;
    icon = iconsource.loadScaledIconFile(path, size);
    if(icon)
    {
        icon->blend(color);
        icon->create();
        return icon;
    }
    else
    {
        icon = new FXPNGIcon(app, empty);
        icon->create();
        return icon;
    }
    return NULL;
}

FXIcon* makeScaledIcon(FXApp* app, const FXString& path, FXuint max, FXColor color)
{
    if(FXStat::exists(path))
    {
        FXIconSource source(app);
        FXIcon *icon;
        icon = source.loadIconFile(path, "png");
        if(icon)
        {
            FXuint w = icon->getWidth();
            FXuint h = icon->getHeight();
            if(w>max || h>max)
            {
                if(w>h)
                    icon->scale(max, (max*h)/w, 1);
                else
                    icon->scale((max*w)/h, max, 1);
            }
            icon->blend(color);
            icon->create();
        }
        else
        {
            icon = source.loadIconFile(path, "jpg");
            if(icon)
            {
                FXuint w = icon->getWidth();
                FXuint h = icon->getHeight();
                if(w>max || h>max)
                {
                    if(w>h)
                        icon->scale(max, (max*h)/w, 1);
                    else
                        icon->scale((max*w)/h, max, 1);
                }
                icon->blend(color);
                icon->create();
            }
            else
                return NULL;
        }
        return icon;
    }
    return NULL;
}

void recreateRoleIcons(FXApp *app, const FXString &path, FXColor color)
{
    textBackColor = color;
    ICO_CHRFOUNDER = makeIcon(app, path, "founder.png", FALSE);
    ICO_CHRHALFOP = makeIcon(app, path, "halfop.png", FALSE);
    ICO_CHRNORMAL = makeIcon(app, path, "normal.png", FALSE);
    ICO_CHROP = makeIcon(app, path, "op.png", FALSE);
    ICO_CHRVOICE = makeIcon(app, path, "voice.png", FALSE);
}

void recreateStatusIcons(FXApp *app, const FXString &path, FXColor color)
{
    textBackColor = color;
    ICO_ROSTERAWAY = makeIcon(app, path, "away.png", FALSE);
    ICO_ROSTERDND = makeIcon(app, path, "dnd.png", FALSE);
    ICO_ROSTERIDLE = makeIcon(app, path, "idle.png", FALSE);
    ICO_ROSTERINVISIBLE = makeIcon(app, path, "invisible.png", FALSE);
    ICO_ROSTEROFFLINE = makeIcon(app, path, "offline.png", FALSE);
    ICO_ROSTERONLINE = makeIcon(app, path, "online.png", FALSE);
}

FXbool makeAllIcons(FXApp *app, const FXString &iniPath, const FXString &datadir)
{
    FXbool success = TRUE;
    FXString mainpath = datadir+PATHSEPSTRING+"icons";
    FXSettings set;
    set.parseFile(iniPath+PATHSEPSTRING+"dxim-fox", TRUE);
    FXString statusPath = DXIM_DATADIR PATHSEPSTRING "icons" PATHSEPSTRING "statuses";
    FXString themeStatusPath = dxutils::checkThemeStatusPath(set.readStringEntry("GENERAL", "themeStatusPath", DXIM_DATADIR PATHSEPSTRING "icons" PATHSEPSTRING "statuses"));
    FXString themeRolePath = dxutils::checkThemeRolePath(set.readStringEntry("GENERAL", "themeRolePath", DXIM_DATADIR PATHSEPSTRING "icons" PATHSEPSTRING "roles"));
    menuColor = set.readColorEntry("LOOK", "basecolor", app->getBaseColor());
    textBackColor = set.readColorEntry("IMTEXT", "textBackColor", FXRGB(255,255,255));

    success = ((ICO_BIGICON = makeIcon(app, mainpath, "dxim.png", TRUE)) != NULL) &success;
    success = ((ICO_SMALLICON = makeIcon(app, mainpath, "dximsmall.png", TRUE)) != NULL) &success;
    success = ((ICO_ABOUTICON = makeIcon(app, mainpath, "dximabout.png", TRUE)) != NULL) &success;
    success = ((ICO_PLAY = makeIcon(app, mainpath, "play.png", TRUE)) != NULL) &success;
    success = ((ICO_NEWM = makeIcon(app, mainpath, "newm.png")) != NULL) &success;
    success = ((ICO_AWAY = makeIcon(app, statusPath, "away.png", TRUE)) != NULL) &success;
    success = ((ICO_INVISIBLE = makeIcon(app, statusPath, "invisible.png", TRUE)) != NULL) &success;
    success = ((ICO_DND = makeIcon(app, statusPath, "dnd.png", TRUE)) != NULL) &success;
    success = ((ICO_OFFLINE = makeIcon(app, statusPath, "offline.png", TRUE)) != NULL) &success;
    success = ((ICO_ONLINE = makeIcon(app, statusPath, "online.png", TRUE)) != NULL) &success;
    success = ((ICO_IDLE = makeIcon(app, statusPath, "idle.png", TRUE)) != NULL) &success;
    success = ((ICO_CLOSEFOLDER = makeIcon(app, mainpath, "folder.png", TRUE)) != NULL) &success;
    success = ((ICO_OPENFOLDER = makeIcon(app, mainpath, "folder_go.png", TRUE)) != NULL) &success;
    success = ((ICO_FILE = makeIcon(app, mainpath, "page.png", TRUE)) != NULL) &success;
    success = ((ICO_IM = makeIcon(app, mainpath, "im.png", TRUE)) != NULL) &success;
    success = ((ICO_IMNEWMSG = makeIcon(app, mainpath, "imnewm.png", TRUE)) != NULL) &success;
    success = ((ICO_IMCOMPOSE = makeIcon(app, mainpath, "imcompose.png", TRUE)) != NULL) &success;
    success = ((ICO_IMOFF = makeIcon(app, mainpath, "imoff.png", TRUE)) != NULL) &success;
    success = ((ICO_CHAT = makeIcon(app, mainpath, "chat.png", TRUE)) != NULL) &success;
    success = ((ICO_CHATNEWMSG = makeIcon(app, mainpath, "chatnewm.png", TRUE)) != NULL) &success;
    success = ((ICO_ROSTERCHAT = makeIcon(app, mainpath, "chat.png", FALSE)) != NULL) &success;
    success = ((ICO_SSL = makeIcon(app, mainpath, "ssl.png", FALSE)) != NULL) &success;
    success = ((ICO_BIGERROR = makeIcon(app, mainpath, "errorbig.png", TRUE)) != NULL) &success;
    success = ((ICO_BIGINFORMATION = makeIcon(app, mainpath, "infobig.png", TRUE)) != NULL) &success;
    success = ((ICO_BIGWARNING = makeIcon(app, mainpath, "warningbig.png", TRUE)) != NULL) &success;
    success = ((ICO_BIGQUESTION = makeIcon(app, mainpath, "questionbig.png", TRUE)) != NULL) &success;
    success = ((ICO_COPY = makeIcon(app, mainpath, "copy.png", TRUE)) != NULL) &success;
    success = ((ICO_SELECTALL = makeIcon(app, mainpath, "select_all.png", TRUE)) != NULL) &success;
    success = ((ICO_FIND = makeIcon(app, mainpath, "find.png", TRUE)) != NULL) &success;
    success = ((ICO_CLEAR = makeIcon(app, mainpath, "clear.png", TRUE)) != NULL) &success;
    success = ((ICO_DOWN = makeIcon(app, mainpath, "arrow_down.png", TRUE)) != NULL) &success;
    success = ((ICO_UP = makeIcon(app, mainpath, "arrow_up.png", TRUE)) != NULL) &success;
    success = ((ICO_CANCEL = makeIcon(app, mainpath, "cancel.png", TRUE)) != NULL) &success;
    success = ((ICO_FINISH = makeIcon(app, mainpath, "finish.png", TRUE)) != NULL) &success;
    success = ((ICO_TRANSFER = makeIcon(app, mainpath, "ft.png", TRUE)) != NULL) &success;
    success = ((ICO_LOGS = makeIcon(app, mainpath, "logs.png", TRUE)) != NULL) &success;
    success = ((ICO_REFRESH = makeIcon(app, mainpath, "arrow_refresh.png", TRUE)) != NULL) &success;
    success = ((ICO_KEYBINDINGS = makeIcon(app, mainpath, "keyboard.png", TRUE)) != NULL) &success;
    success = ((ICO_INFORMATION = makeIcon(app, mainpath, "info.png", TRUE)) != NULL) &success;
    success = ((ICO_WARNING = makeIcon(app, mainpath, "warning.png", TRUE)) != NULL) &success;
    success = ((ICO_EMAIL = makeIcon(app, mainpath, "email.png", TRUE)) != NULL) &success;
    success = ((ICO_QUESTION = makeIcon(app, mainpath, "question.png", TRUE)) != NULL) &success;
    success = ((ICO_ROSTEROPENED = makeIcon(app, mainpath, "groupopen.png", FALSE)) != NULL) &success;
    success = ((ICO_ROSTERCLOSED = makeIcon(app, mainpath, "groupclose.png", FALSE)) != NULL) &success;
    success = ((ICO_ROSTERAWAY = makeIcon(app, themeStatusPath, "away.png", FALSE)) != NULL) &success;
    success = ((ICO_ROSTERDND = makeIcon(app, themeStatusPath, "dnd.png", FALSE)) != NULL) &success;
    success = ((ICO_ROSTERIDLE = makeIcon(app, themeStatusPath, "idle.png", FALSE)) != NULL) &success;
    success = ((ICO_ROSTERINVISIBLE = makeIcon(app, themeStatusPath, "invisible.png", FALSE)) != NULL) &success;
    success = ((ICO_ROSTEROFFLINE = makeIcon(app, themeStatusPath, "offline.png", FALSE)) != NULL) &success;
    success = ((ICO_ROSTERONLINE = makeIcon(app, themeStatusPath, "online.png", FALSE)) != NULL) &success;
    success = ((ICO_ROSTERCONNECTING = makeIcon(app, mainpath, "connecting.png", FALSE)) != NULL) &success;
    success = ((ICO_WLM = makeIcon(app, mainpath+PATHSEPSTRING+"protocols", "wlm.png", TRUE)) != NULL) &success;
    success = ((ICO_XMPP = makeIcon(app, mainpath+PATHSEPSTRING+"protocols", "xmpp.png", TRUE)) != NULL) &success;
    success = ((ICO_IRC = makeIcon(app, mainpath+PATHSEPSTRING+"protocols", "irc.png", TRUE)) != NULL) &success;
    success = ((ICO_ICQ = makeIcon(app, mainpath+PATHSEPSTRING+"protocols", "icq.png", TRUE)) != NULL) &success;
    success = ((ICO_AIM = makeIcon(app, mainpath+PATHSEPSTRING+"protocols", "aim.png", TRUE)) != NULL) &success;
    success = ((ICO_BONJOUR = makeIcon(app, mainpath+PATHSEPSTRING+"protocols", "bonjour.png", TRUE)) != NULL) &success;
    success = ((ICO_GG = makeIcon(app, mainpath+PATHSEPSTRING+"protocols", "gadu-gadu.png", TRUE)) != NULL) &success;
    success = ((ICO_NOVELL = makeIcon(app, mainpath+PATHSEPSTRING+"protocols", "novell.png", TRUE)) != NULL) &success;
    success = ((ICO_MYSPACE = makeIcon(app, mainpath+PATHSEPSTRING+"protocols", "myspace.png", TRUE)) != NULL) &success;
    success = ((ICO_SILC = makeIcon(app, mainpath+PATHSEPSTRING+"protocols", "silc.png", TRUE)) != NULL) &success;
    success = ((ICO_MEANWHILE = makeIcon(app, mainpath+PATHSEPSTRING+"protocols", "meanwhile.png", TRUE)) != NULL) &success;
    success = ((ICO_SIMPLE = makeIcon(app, mainpath+PATHSEPSTRING+"protocols", "simple.png", TRUE)) != NULL) &success;
    success = ((ICO_YAHOO = makeIcon(app, mainpath+PATHSEPSTRING+"protocols", "yahoo.png", TRUE)) != NULL) &success;
    success = ((ICO_SKYPE = makeIcon(app, mainpath+PATHSEPSTRING+"protocols", "skype.png", TRUE)) != NULL) &success;
    success = ((ICO_MXIT = makeIcon(app, mainpath+PATHSEPSTRING+"protocols", "mxit.png", TRUE)) != NULL) &success;
    success = ((ICO_ZEPHYR = makeIcon(app, mainpath+PATHSEPSTRING+"protocols", "zephyr.png", TRUE)) != NULL) &success;
    success = ((ICO_TELEGRAM = makeIcon(app, mainpath+PATHSEPSTRING+"protocols", "telegram.png", TRUE)) != NULL) &success;
    success = ((ICO_SLACK = makeIcon(app, mainpath+PATHSEPSTRING+"protocols", "slack.png", TRUE)) != NULL) &success;
    success = ((ICO_CHRFOUNDER = makeIcon(app, themeRolePath, "founder.png", FALSE)) != NULL) &success;
    success = ((ICO_CHRHALFOP = makeIcon(app, themeRolePath, "halfop.png", FALSE)) != NULL) &success;
    success = ((ICO_CHRNORMAL = makeIcon(app, themeRolePath, "normal.png", FALSE)) != NULL) &success;
    success = ((ICO_CHROP = makeIcon(app, themeRolePath, "op.png", FALSE)) != NULL) &success;
    success = ((ICO_CHRVOICE = makeIcon(app, themeRolePath, "voice.png", FALSE)) != NULL) &success;
    return success;
}
