/*
 *      icons.h
 *
 *      Copyright 2010 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */


#ifndef ICONS_H
#define ICONS_H

FXIcon* makeIcon(FXApp *app, const FXString path, const FXString name, const FXbool menu);
FXIcon* makeIcon(FXApp *app, const FXString path, const FXString name);
FXIcon* makeIcon(FXApp* app, const FXString& path, FXint size=16, FXColor color=FXRGB(0,0,0));
FXIcon* makeScaledIcon(FXApp* app, const FXString& path, FXuint max, FXColor color);
FXbool makeAllIcons(FXApp *app, const FXString &iniPath, const FXString &datadir);
void recreateRoleIcons(FXApp *app, const FXString &path, FXColor color);
void recreateStatusIcons(FXApp *app, const FXString &path, FXColor color);

extern FXIcon *ICO_BIGICON;
extern FXIcon *ICO_SMALLICON;
extern FXIcon *ICO_ABOUTICON;
extern FXIcon *ICO_NEWM;
extern FXIcon *ICO_AWAY;
extern FXIcon *ICO_INVISIBLE;
extern FXIcon *ICO_DND;
extern FXIcon *ICO_OFFLINE;
extern FXIcon *ICO_ONLINE;
extern FXIcon *ICO_IDLE;
extern FXIcon *ICO_PLAY;
extern FXIcon *ICO_CLOSEFOLDER;
extern FXIcon *ICO_OPENFOLDER;
extern FXIcon *ICO_FILE;
extern FXIcon *ICO_IM;
extern FXIcon *ICO_IMNEWMSG;
extern FXIcon *ICO_IMCOMPOSE;
extern FXIcon *ICO_IMOFF;
extern FXIcon *ICO_CHAT;
extern FXIcon *ICO_CHATNEWMSG;
extern FXIcon *ICO_ROSTERCHAT;
extern FXIcon *ICO_SSL;
extern FXIcon *ICO_BIGINFORMATION;
extern FXIcon *ICO_BIGWARNING;
extern FXIcon *ICO_BIGERROR;
extern FXIcon *ICO_BIGQUESTION;
extern FXIcon *ICO_CLEAR;
extern FXIcon *ICO_SELECTALL;
extern FXIcon *ICO_COPY;
extern FXIcon *ICO_FIND;
extern FXIcon *ICO_DOWN;
extern FXIcon *ICO_UP;
extern FXIcon *ICO_CANCEL;
extern FXIcon *ICO_FINISH;
extern FXIcon *ICO_TRANSFER;
extern FXIcon *ICO_REFRESH;
extern FXIcon *ICO_KEYBINDINGS;
extern FXIcon *ICO_INFORMATION;
extern FXIcon *ICO_WARNING;
extern FXIcon *ICO_QUESTION;
extern FXIcon *ICO_EMAIL;
extern FXIcon *ICO_ROSTEROPENED;
extern FXIcon *ICO_ROSTERCLOSED;
extern FXIcon *ICO_LOGS;
//statuses
extern FXIcon *ICO_ROSTERAWAY;
extern FXIcon *ICO_ROSTERDND;
extern FXIcon *ICO_ROSTERIDLE;
extern FXIcon *ICO_ROSTERINVISIBLE;
extern FXIcon *ICO_ROSTEROFFLINE;
extern FXIcon *ICO_ROSTERONLINE;
extern FXIcon *ICO_ROSTERCONNECTING;
//protocols
extern FXIcon *ICO_XMPP;
extern FXIcon *ICO_WLM;
extern FXIcon *ICO_IRC;
extern FXIcon *ICO_ICQ;
extern FXIcon *ICO_AIM;
extern FXIcon *ICO_BONJOUR;
extern FXIcon *ICO_GG;
extern FXIcon *ICO_NOVELL;
extern FXIcon *ICO_MYSPACE;
extern FXIcon *ICO_SILC;
extern FXIcon *ICO_MEANWHILE;
extern FXIcon *ICO_SIMPLE;
extern FXIcon *ICO_YAHOO;
extern FXIcon *ICO_SKYPE;
extern FXIcon *ICO_MXIT;
extern FXIcon *ICO_ZEPHYR;
extern FXIcon *ICO_TELEGRAM;
extern FXIcon *ICO_SLACK;
//chat roles
extern FXIcon *ICO_CHRFOUNDER;
extern FXIcon *ICO_CHRHALFOP;
extern FXIcon *ICO_CHRNORMAL;
extern FXIcon *ICO_CHROP;
extern FXIcon *ICO_CHRVOICE;

extern const unsigned char empty[];
extern const unsigned char small_dxim[];
extern const unsigned char big_dxim[];

#endif // ICONS_H
