/*
 *      msgtabitem.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef MSGTABITEM_H
#define MSGTABITEM_H

#include "dxtabitem.h"

class MsgTabItem : public dxTabItem
{
    FXDECLARE(MsgTabItem)
public:
    MsgTabItem(dxTabBook *tab, const FXString &tabtext, MsgInfo msg, FXIcon *icon=0, FXuint opts=TAB_TOP_NORMAL);
    virtual ~MsgTabItem();

    long onMsgOk(FXObject *, FXSelector, void *);
    long onMsgCancel(FXObject *, FXSelector, void *);

    void createGeom();
private:
    MsgTabItem() {}

    FXVerticalFrame *m_contents;
    FXLabel *m_msgIcon;
    dxEXButton *m_msgOkButton, *m_msgCancelButton;
    MsgInfo m_message;

    void showMsg();
};

#endif  /* MSGTABITEM_H */

