/*
 *      texttabitem.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef TEXTTABITEM_H
#define TEXTTABITEM_H

#include "dxtabitem.h"

class TextTabItem : public dxTabItem
{
    FXDECLARE(TextTabItem)
public:
    TextTabItem(dxTabBook *tab, const FXString &id, const FXString &tabtext, FXIcon *ic=0, FXuint opts=TAB_TOP_NORMAL);
    virtual ~TextTabItem();

    long onOk(FXObject*, FXSelector, void*);

    void clearText();
    void createGeom();
    void appendText(const FXString &msg);
    void appendStyledText(const FXString &text, FXint style, FXString time);
    void appendSmiley(dxSmiley smiley);
    FXString getID() const { return m_id; }
    void showLog(const FXString &path);
private:
    TextTabItem() {}

    FXString m_id;
    dxTabBook *m_parent;
    FXVerticalFrame *m_textframe, *m_mainframe;
    
    FXint stringToStyle(FXString style);
    FXint getNickStyle(const FXString &nick);
};

#endif  /* IMTABITEM_H */

