/*
 *      accountdialog.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef ACCOUNTDIALOG_H
#define ACCOUNTDIALOG_H

#include <gtkmm.h>
#include <purplemm.h>

class AccountDialog : public Gtk::Dialog {
public:
    AccountDialog(Gtk::Window& parent, PURPLE::Purple*);
    virtual ~AccountDialog();
private:
    PURPLE::Purple *m_purple;
    struct AccountModelColumns : public Gtk::TreeModel::ColumnRecord
    {
        Gtk::TreeModelColumn<Glib::RefPtr<Gdk::Pixbuf> > m_userIcon;
        Gtk::TreeModelColumn<Glib::ustring> m_userName;
        Gtk::TreeModelColumn<Glib::RefPtr<Gdk::Pixbuf> > m_protocolIcon;
        Gtk::TreeModelColumn<Glib::ustring> m_protocolName;
        Gtk::TreeModelColumn<bool> m_enabled;
        Gtk::TreeModelColumn<PURPLE::Account> m_account;

        AccountModelColumns() { add(m_userIcon); add(m_userName); add(m_protocolIcon); add(m_protocolName); add(m_enabled); add(m_account); }
    };
    const AccountModelColumns m_accountColumns;
    Glib::RefPtr<Gtk::ListStore> m_accountModel;
    Glib::RefPtr<Gtk::TreeSelection> m_accountSelectionModel;
    Gtk::TreeView m_accounts;
    Gtk::Button *m_add, *m_modify, *m_delete;

    void updateButtons();
    void onEnabledChanged(const Glib::ustring &path_string);
    void addAccount();
    void modifyAccount();
    void deleteAccount();
    void createAccount(PURPLE::Account account);
};

#endif  /* ACCOUNTDIALOG_H */

