/*
 *      chatdialog.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef CHATDIALOG_H
#define CHATDIALOG_H

#include <gtkmm.h>
#include <purplemm.h>

class ChatDialog : public Gtk::Dialog {
public:
    //for create new PURPLE::Chat
    ChatDialog(PURPLE::Account);
    //for modify PURPLE::Chat
    ChatDialog(PURPLE::Chat);
    virtual ~ChatDialog();
private:
    PURPLE::Account m_account;
    PURPLE::Chat m_chat;
    Gtk::Table *m_table;
    std::vector<Gtk::Widget*> m_fields;
    Gtk::CheckButton *m_autoJoin;
    Gtk::Entry *m_alias;
    Gtk::ComboBoxText *m_groups;
    bool m_modifing;

    //slot start
    void onOK();
    //slot end
    void createWidgets();
    Glib::ustring createLabel(std::string label);
    std::vector<PURPLE::Account::ChatEntry> fillChatEntryFields();
};

#endif  /* CHATDIALOG_H */

