/*
 *      chatjoindialog.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef CHATJOINDIALOG_H
#define CHATJOINDIALOG_H

#include <gtkmm.h>
#include <purplemm.h>
#include "callback/callback.h"

class ChatJoinDialog : public Gtk::Dialog {
public:
    ChatJoinDialog(Gtk::Window& parent, PURPLE::Purple*, dxgCallbacks*);
    ChatJoinDialog(PURPLE::Account, dxgCallbacks*);
    virtual ~ChatJoinDialog();
private:
    dxgCallbacks *m_cb;
    Gtk::Table *m_table;
    struct ModelColumns : public Gtk::TreeModel::ColumnRecord
    {
        Gtk::TreeModelColumn<Glib::RefPtr<Gdk::Pixbuf> > m_icon;
        Gtk::TreeModelColumn<Glib::ustring> m_name;
        Gtk::TreeModelColumn<PURPLE::Account> m_account;

        ModelColumns() { add(m_icon); add(m_name); add(m_account); }
    };
    const ModelColumns m_idColumns;
    Glib::RefPtr<Gtk::TreeStore> m_idModel;
    Gtk::ComboBox m_ids;
    std::vector<Gtk::Widget*> m_fields;
    Gtk::Button *m_chatButton;

    //slot start
    void onAccount();
    void onGetChats();
    void onJoin();
    void onRoomListClosed(bool success, Glib::ustring selected);
    //slot end
    //purplemm slot start
    void onRoomlistCreated(PURPLE::RoomList *rlist);
    //purplemm slot end
    void createChatEntryFields(std::vector<PURPLE::Account::ChatEntry> fields);
    Glib::ustring createLabel(std::string label);
    std::vector<PURPLE::Account::ChatEntry> fillChatEntryFields();
    void createControls(std::vector<PURPLE::Account> accounts);
};

#endif  /* CHATJOINDIALOG_H */

