/*
 *      choicerequestdialog.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef CHOICEREQUESTDIALOG_H
#define CHOICEREQUESTDIALOG_H

#include <gtkmm.h>
#include <purplemm.h>

class ChoiceRequestDialog : public Gtk::Dialog {
public:
    ChoiceRequestDialog(Gtk::Window& parent, PURPLE::ChoiceRequest*);
    virtual ~ChoiceRequestDialog();

    void on_response(int);
private:
    struct Columns : public Gtk::TreeModel::ColumnRecord
    {
        Gtk::TreeModelColumn<Glib::ustring> m_label;
        Gtk::TreeModelColumn<int> m_id;
        Columns() { add(m_label); add(m_id); }
    };
    const Columns m_columns;
    Glib::RefPtr<Gtk::ListStore> m_model;
    Gtk::TreeView *m_list;
    PURPLE::ChoiceRequest *m_request;
};

#endif  /* CHOICEREQUESTDIALOG_H */

