/*
 *      imdialog.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef IMDIALOG_H
#define IMDIALOG_H

#include <gtkmm.h>
#include <purplemm.h>

class IMDialog : public Gtk::Dialog {
public:
    IMDialog(Gtk::Window& parent, PURPLE::Purple* purple);
    IMDialog(PURPLE::Account account, PURPLE::Purple* purple);
    virtual ~IMDialog();

    void on_response(int);
private:
    PURPLE::Purple *m_purple;
    Gtk::Table *m_table;
    struct IdModelColumns : public Gtk::TreeModel::ColumnRecord
    {
        Gtk::TreeModelColumn<Glib::RefPtr<Gdk::Pixbuf> > m_icon;
        Gtk::TreeModelColumn<Glib::ustring> m_name;
        Gtk::TreeModelColumn<PURPLE::Account> m_account;

        IdModelColumns() { add(m_icon); add(m_name); add(m_account); }
    };
    const IdModelColumns m_idColumns;
    Glib::RefPtr<Gtk::TreeStore> m_idModel;
    Gtk::ComboBox m_ids;
    struct WithModelColumns : public Gtk::TreeModel::ColumnRecord
    {
        Gtk::TreeModelColumn<Glib::ustring> m_name;
        Gtk::TreeModelColumn<Glib::ustring> m_hint;

        WithModelColumns() { add(m_name); add(m_hint); }
    };
    const WithModelColumns m_withColumns;
    Glib::RefPtr<Gtk::ListStore> m_withModel;
    Gtk::Entry m_with;

    //slot start
    void onAccount();
    bool onCompleter(const Gtk::TreeModel::iterator& it);
    //slot end
    void fillCompleter(std::vector<PURPLE::Buddy> buddies);
    void createControls(std::vector<PURPLE::Account> accounts);
};

#endif  /* IMDIALOG_H */

