/*
 *      inputrequestdialog.cpp
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#include "inputrequestdialog.h"
#include "config.h"
#include "i18n.h"

InputRequestDialog::InputRequestDialog(Gtk::Window& parent, PURPLE::InputRequest* request)
: Gtk::Dialog(request->getTitle().empty()?_("New request"):request->getTitle(), parent), m_request(request)
{
    add_button(Gtk::Stock::CANCEL, Gtk::RESPONSE_CANCEL);
    add_button(m_request->getOkText(), Gtk::RESPONSE_OK);
    get_vbox()->pack_start(*Gtk::manage(new Gtk::Label(m_request->getPrimary(), Gtk::ALIGN_START)));
    if(!m_request->getSecondary().empty()) get_vbox()->pack_start(*Gtk::manage(new Gtk::Label(m_request->getSecondary(), Gtk::ALIGN_START)));
    get_vbox()->pack_end(m_inputEntry);
    m_inputEntry.set_text(m_request->getDefaultValue());
    show_all();
}

InputRequestDialog::~InputRequestDialog()
{
}

void InputRequestDialog::on_response(int response)
{
    if(response == Gtk::RESPONSE_OK)
        m_request->sendInput(m_inputEntry.get_text());
    else
        m_request->dennyRequest();
}

