/*
 *      plugindialog.h
 *
 *      Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef PLUGINDIALOG_H
#define PLUGINDIALOG_H

#include <gtkmm.h>
#include <purplemm.h>
#include "../widgets/linklabel.h"

class PluginDialog : public Gtk::Dialog {
public:
    PluginDialog(Gtk::Window& parent, PURPLE::Purple*);
    virtual ~PluginDialog();
private:
    std::vector<PURPLE::Plugin> m_plugins;
    struct PluginModelColumns : public Gtk::TreeModel::ColumnRecord
    {
        Gtk::TreeModelColumn<Glib::ustring> m_pluginName;
        Gtk::TreeModelColumn<bool> m_enabled;
        Gtk::TreeModelColumn<PURPLE::Plugin> m_plugin;

        PluginModelColumns() { add(m_pluginName); add(m_enabled); add(m_plugin); }
    };
    const PluginModelColumns m_pluginColumns;
    Glib::RefPtr<Gtk::ListStore> m_pluginModel;
    Glib::RefPtr<Gtk::TreeSelection> m_pluginSelectionModel;
    Gtk::TreeView m_pluginsList;
    Gtk::Button *m_modify;
    Gtk::Expander *m_details;
    Gtk::TextView *m_summary, *m_description;
    Gtk::Label *m_version, *m_author, *m_path;
    LinkLabel *m_homepage;

    void onSelectionChanged();
    void onEnabledChanged(const Glib::ustring &path_string);
    void onOK();
    void modifyPlugin();
    void createPlugin(PURPLE::Plugin plugin);
};

#endif  /* PLUGINDIALOG_H */

