/*
 *      dxpipe.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef DXPIPE_H
#define DXPIPE_H

#include <sigc++/sigc++.h>
#include <glibmm.h>
#ifndef _WIN32
#include <unistd.h>
#include <signal.h>
#include <sys/wait.h>
#endif

class dxPipe
{
public:
    dxPipe();
    virtual ~dxPipe();

    sigc::signal<void, Glib::ustring> signalText;

    int execCmd(Glib::ustring);
    bool getRunning() { return m_running; }
    void stopCmd();
    void closePipe();
    Glib::ustring getCommand() const;
private:
    dxPipe(const dxPipe& orig);

    bool readData(Glib::IOCondition io_condition);

    int m_in[2], m_out[2];
    int m_pid;
    Glib::ustring m_command;
    bool m_running;
    Glib::RefPtr<Glib::IOChannel> m_iochannel;
};

#endif  /* DXPIPE_H */

