/*
 *      icons.cpp
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#include "preferences.h"
#include "icons.h"
#include "config.h"
#include "i18n.h"

static const char * dxim_xpm[] = {
"16 16 86 1",
"   c None",
".  c #7A7A78",
"+  c #6E7270",
"@  c #868789",
"#  c #C1C1C0",
"$  c #BEBEBE",
"%  c #828486",
"&  c #939391",
"*  c #A8A9A8",
"=  c #B5B7B5",
"-  c #B3B5B3",
";  c #A5A8A5",
">  c #959896",
",  c #535960",
"'  c #524C4B",
")  c #4D504E",
"!  c #777975",
"~  c #737471",
"{  c #4C4F4E",
"]  c #4F494B",
"^  c #505660",
"/  c #545961",
"(  c #B76B28",
"_  c #665546",
":  c #515351",
"<  c #4C4E4E",
"[  c #50494A",
"}  c #525761",
"|  c #54585E",
"1  c #C16F25",
"2  c #4A4D4C",
"3  c #8A633D",
"4  c #A26836",
"5  c #A86930",
"6  c #B26828",
"7  c #515661",
"8  c #9C6535",
"9  c #C76F20",
"0  c #484B4A",
"a  c #C67425",
"b  c #9A6434",
"c  c #C77123",
"d  c #BC6B23",
"e  c #4F5560",
"f  c #50555D",
"g  c #B56925",
"h  c #885D34",
"i  c #D8771C",
"j  c #524E46",
"k  c #B26A27",
"l  c #BD6B21",
"m  c #4E545F",
"n  c #4F545C",
"o  c #B66621",
"p  c #AB6624",
"q  c #AF6725",
"r  c #4E4B44",
"s  c #AA6525",
"t  c #B56520",
"u  c #4C515D",
"v  c #4D535B",
"w  c #4A4442",
"x  c #474745",
"y  c #5C5B57",
"z  c #5A5954",
"A  c #464744",
"B  c #484143",
"C  c #4B525D",
"D  c #666662",
"E  c #6E6D67",
"F  c #71675D",
"G  c #706454",
"H  c #766B5D",
"I  c #77695A",
"J  c #6F6254",
"K  c #71665D",
"L  c #6C6B69",
"M  c #5D5D5F",
"N  c #34383B",
"O  c #353A3A",
"P  c #373B3D",
"Q  c #383D3B",
"R  c #373F3D",
"S  c #2E2F31",
"T  c #1C1F1F",
"U  c #313535",
"                ",
"       .+       ",
"      @#$%      ",
"     &*=-;>     ",
"    ,')!~{]^    ",
"    /(_::<[}    ",
"    |1234567    ",
"    890abcde    ",
"    fghijklm    ",
"    nopqrstu    ",
"    vwxyzABC    ",
"   DEFGHIJKLM   ",
"    NO  P QR    ",
"     S  T U     ",
"                ",
"                "};

static const char * picture_empty_xpm[] = {
"16 16 130 2",
"   c #FFFFFF",
".  c #CBD5E4",
"+  c #A8B8D3",
"@  c #9BB0D0",
"#  c #95ACD0",
"$  c #95ABD0",
"%  c #99AFD0",
"&  c #C7D2E3",
"*  c #A7B9D3",
"=  c #EBECEC",
"-  c #F3F4F4",
";  c #F4F5F7",
">  c #F3F5F7",
",  c #F2F5F7",
"'  c #F0F5F7",
")  c #F0F5F8",
"!  c #EFF4F8",
"~  c #EEF3F8",
"{  c #ECF3F8",
"]  c #ECF3F7",
"^  c #E9EFF2",
"/  c #9EB2D1",
"(  c #F2F3F4",
"_  c #96B5E3",
":  c #93B2E2",
"<  c #8FB0E0",
"[  c #8CADDF",
"}  c #88AADD",
"|  c #84A7DC",
"1  c #81A5DA",
"2  c #7EA2D9",
"3  c #7BA0D8",
"4  c #799ED7",
"5  c #EBF2F7",
"6  c #9AB0D2",
"7  c #96ACD0",
"8  c #97B5E4",
"9  c #93B3E2",
"0  c #90B0E1",
"a  c #85A8DC",
"b  c #7EA3D9",
"c  c #7CA1D8",
"d  c #7A9FD7",
"e  c #E9F0F7",
"f  c #94B3E2",
"g  c #A88685",
"h  c #BA5826",
"i  c #BB4204",
"j  c #B3501B",
"k  c #9C7875",
"l  c #80A4DA",
"m  c #7DA2D9",
"n  c #E8F0F6",
"o  c #9AB0D1",
"p  c #98B6E4",
"q  c #AA8887",
"r  c #CF743B",
"s  c #F7B58D",
"t  c #FED6B8",
"u  c #F5A872",
"v  c #CA6B2F",
"w  c #997B7F",
"x  c #E7EFF5",
"y  c #EFF4F7",
"z  c #99B7E5",
"A  c #B45320",
"B  c #F6B58D",
"C  c #FF924D",
"D  c #FF7711",
"E  c #FF8621",
"F  c #EB8A40",
"G  c #B2501F",
"H  c #83A6DB",
"I  c #E7EEF6",
"J  c #EEF3F7",
"K  c #9AB8E5",
"L  c #FECDAE",
"M  c #EF7F18",
"N  c #86A8DC",
"O  c #EDF2F7",
"P  c #9CB9E6",
"Q  c #B5511B",
"R  c #F49D63",
"S  c #FF7F18",
"T  c #F87600",
"U  c #EE7600",
"V  c #E16803",
"W  c #B44F1A",
"X  c #89ABDE",
"Y  c #E6EEF6",
"Z  c #ECF1F7",
"`  c #9DBAE6",
" . c #AF877F",
".. c #C86527",
"+. c #E67721",
"@. c #EA7905",
"#. c #DD6401",
"$. c #BC4E06",
"%. c #A27C76",
"&. c #8DAEDF",
"*. c #94ABCF",
"=. c #EDF1F7",
"-. c #9EBBE7",
";. c #AE8A86",
">. c #B4531F",
",. c #A47D77",
"'. c #91B1E1",
"). c #E6EDF6",
"!. c #99AFD1",
"~. c #95ABCF",
"{. c #EDF1F6",
"]. c #A0BCE7",
"^. c #9BB8E5",
"/. c #97B6E4",
"(. c #95B4E3",
"_. c #E6EDF7",
":. c #A2B5D3",
"<. c #EDEFF1",
"[. c #F1F3F7",
"}. c #F1F4F8",
"|. c #F0F4F8",
"1. c #F0F4F7",
"2. c #F0F3F7",
"3. c #EFF3F7",
"4. c #EFF3F8",
"5. c #EBEFF2",
"6. c #9EB2D2",
"7. c #C9D4E4",
"8. c #B2C1DA",
"9. c #9DB2D1",
"                                ",
"  . + @ # # # # # $ $ $ $ % &   ",
"  * = - ; > , ' ) ! ~ { ] ^ /   ",
"  @ ( _ : < [ } | 1 2 3 4 5 6   ",
"  7 ; 8 9 0 [ } a 1 b c d e 6   ",
"  7 , 8 f g h i j k l m c n o   ",
"  7 ' p q r s t u v w l b x o   ",
"  7 y z A B C D E F G H 1 I o   ",
"  7 J K i L       M i N a I o   ",
"  # O P Q R S T U V W X } Y o   ",
"  # Z `  ...+.@.#.$.%.&.[ Y o   ",
"  *.=.-.` ;.>.i Q ,.'.0 0 ).!.  ",
"  ~.{.].-.` ^.z /._ (.f 9 _.!.  ",
"  :.<.[.}.|.1.2.3.3.3.3.4.5.6.  ",
"  7.8.o !.!.!.!.!.!.!.!.!.9.&   ",
"                                "};

Gtk::Image *ICO_BIGICON;
Gtk::Image *ICO_SMALLICON;
Gtk::Image *ICO_ABOUTICON;
Gtk::Image *ICO_IM;
Gtk::Image *ICO_IMNEWMSG;
Gtk::Image *ICO_IMCOMPOSE;
Gtk::Image *ICO_IMOFF;
Gtk::Image *ICO_CHAT;
Gtk::Image *ICO_CHATNEWMSG;
Gtk::Image *ICO_FOLDER;
Gtk::Image *ICO_FILE;
Gtk::Image *ICO_INFO;
Gtk::Image *ICO_EMAIL;
Gtk::Image *ICO_DOWN;
Gtk::Image *ICO_UP;
Gtk::Image *ICO_CANCEL;
Gtk::Image *ICO_FINISH;
//statuses
Gtk::Image *ICO_AWAY;
Gtk::Image *ICO_INVISIBLE;
Gtk::Image *ICO_DND;
Gtk::Image *ICO_OFFLINE;
Gtk::Image *ICO_ONLINE;
Gtk::Image *ICO_IDLE;
Gtk::Image *ICO_CONNECTING;
//protocols
Gtk::Image *ICO_XMPP;
Gtk::Image *ICO_WLM;
Gtk::Image *ICO_IRC;
Gtk::Image *ICO_ICQ;
Gtk::Image *ICO_AIM;
Gtk::Image *ICO_BONJOUR;
Gtk::Image *ICO_GG;
Gtk::Image *ICO_NOVELL;
Gtk::Image *ICO_MYSPACE;
Gtk::Image *ICO_SILC;
Gtk::Image *ICO_MEANWHILE;
Gtk::Image *ICO_SIMPLE;
Gtk::Image *ICO_YAHOO;
Gtk::Image *ICO_SKYPE;
Gtk::Image *ICO_MXIT;
Gtk::Image *ICO_ZEPHYR;
Gtk::Image *ICO_TELEGRAM;
Gtk::Image *ICO_SLACK;
//chat roles
Gtk::Image *ICO_CHRFOUNDER;
Gtk::Image *ICO_CHRHALFOP;
Gtk::Image *ICO_CHRNORMAL;
Gtk::Image *ICO_CHROP;
Gtk::Image *ICO_CHRVOICE;

Glib::RefPtr<Gdk::Pixbuf> createPixbuf(const Glib::ustring &path)
{
    Glib::RefPtr<Gdk::Pixbuf> pixbuf;
    if(Glib::file_test(path, Glib::FILE_TEST_EXISTS)
       && !Glib::file_test(path, Glib::FILE_TEST_IS_DIR))
    {
        try {
            pixbuf = Gdk::Pixbuf::create_from_file(path);
        }
        catch (...) {
            if(path.find("dxim.png")!=Glib::ustring::npos || path.find("dximsmall.png")!=Glib::ustring::npos
                    || path.find("dximabout.png")!=Glib::ustring::npos)
                pixbuf = Gdk::Pixbuf::create_from_xpm_data(dxim_xpm);
            else
                pixbuf = Gdk::Pixbuf::create_from_xpm_data(picture_empty_xpm);
        }
    }
    else
    {
        if(path.find("dxim.png")!=Glib::ustring::npos || path.find("dximsmall.png")!=Glib::ustring::npos
                || path.find("dximabout.png")!=Glib::ustring::npos)
            pixbuf = Gdk::Pixbuf::create_from_xpm_data(dxim_xpm);
        else
            pixbuf = Gdk::Pixbuf::create_from_xpm_data(picture_empty_xpm);
    }
    return pixbuf;
}

void createIcon(Gtk::Image *img, const Glib::ustring &path)
{
    img->set(createPixbuf(path));
}

void createStockItem(const Glib::RefPtr<Gtk::IconFactory> &factory,
  const std::string &filepath,
  const Glib::ustring &id, const Glib::ustring &label)
{
    Gtk::IconSource source;
    source.set_pixbuf(createPixbuf(filepath));
    source.set_size(Gtk::ICON_SIZE_SMALL_TOOLBAR);
    source.set_size_wildcarded();
#if GTKMM_MAJOR_VERSION == 2
    Gtk::IconSet icon_set;
    icon_set.add_source(source);
#else
    Glib::RefPtr<Gtk::IconSet> icon_set = Gtk::IconSet::create();
    icon_set->add_source(source);
#endif
    const Gtk::StockID stock_id(id);
    factory->add(stock_id, icon_set);
    Gtk::Stock::add(Gtk::StockItem(stock_id, label));
}

void createStatusIcons()
{
    createIcon(ICO_AWAY, DXPREFERENCES.m_themeStatusPath+G_DIR_SEPARATOR_S+"away.png");
    createIcon(ICO_INVISIBLE, DXPREFERENCES.m_themeStatusPath+G_DIR_SEPARATOR_S+"invisible.png");
    createIcon(ICO_DND, DXPREFERENCES.m_themeStatusPath+G_DIR_SEPARATOR_S+"dnd.png");
    createIcon(ICO_OFFLINE, DXPREFERENCES.m_themeStatusPath+G_DIR_SEPARATOR_S+"offline.png");
    createIcon(ICO_ONLINE, DXPREFERENCES.m_themeStatusPath+G_DIR_SEPARATOR_S+"online.png");
    createIcon(ICO_IDLE, DXPREFERENCES.m_themeStatusPath+G_DIR_SEPARATOR_S+"idle.png");
}

void createRoleIcons()
{
    createIcon(ICO_CHRFOUNDER, DXPREFERENCES.m_themeRolePath+G_DIR_SEPARATOR_S+"founder.png");
    createIcon(ICO_CHRHALFOP, DXPREFERENCES.m_themeRolePath+G_DIR_SEPARATOR_S+"halfop.png");
    createIcon(ICO_CHRNORMAL, DXPREFERENCES.m_themeRolePath+G_DIR_SEPARATOR_S+"normal.png");
    createIcon(ICO_CHROP, DXPREFERENCES.m_themeRolePath+G_DIR_SEPARATOR_S+"op.png");
    createIcon(ICO_CHRVOICE, DXPREFERENCES.m_themeRolePath+G_DIR_SEPARATOR_S+"voice.png");
}

void makeIcons()
{
    ICO_BIGICON = Gtk::manage(new Gtk::Image());
    ICO_SMALLICON = Gtk::manage(new Gtk::Image());
    ICO_ABOUTICON = Gtk::manage(new Gtk::Image());
    ICO_IM = Gtk::manage(new Gtk::Image());
    ICO_IMNEWMSG = Gtk::manage(new Gtk::Image());
    ICO_IMCOMPOSE = Gtk::manage(new Gtk::Image());
    ICO_IMOFF = Gtk::manage(new Gtk::Image());
    ICO_CHAT = Gtk::manage(new Gtk::Image());
    ICO_CHATNEWMSG = Gtk::manage(new Gtk::Image());
    ICO_FOLDER = Gtk::manage(new Gtk::Image());
    ICO_FILE = Gtk::manage(new Gtk::Image());
    ICO_INFO = Gtk::manage(new Gtk::Image());
    ICO_EMAIL = Gtk::manage(new Gtk::Image());
    ICO_DOWN = Gtk::manage(new Gtk::Image());
    ICO_UP = Gtk::manage(new Gtk::Image());
    ICO_CANCEL = Gtk::manage(new Gtk::Image());
    ICO_FINISH = Gtk::manage(new Gtk::Image());
    //statuses
    ICO_AWAY = Gtk::manage(new Gtk::Image());
    ICO_INVISIBLE = Gtk::manage(new Gtk::Image());
    ICO_DND = Gtk::manage(new Gtk::Image());
    ICO_OFFLINE = Gtk::manage(new Gtk::Image());
    ICO_ONLINE = Gtk::manage(new Gtk::Image());
    ICO_IDLE = Gtk::manage(new Gtk::Image());
    ICO_CONNECTING = Gtk::manage(new Gtk::Image());
    //protocols
    ICO_XMPP = Gtk::manage(new Gtk::Image());
    ICO_WLM = Gtk::manage(new Gtk::Image());
    ICO_IRC = Gtk::manage(new Gtk::Image());
    ICO_ICQ = Gtk::manage(new Gtk::Image());
    ICO_AIM = Gtk::manage(new Gtk::Image());
    ICO_BONJOUR = Gtk::manage(new Gtk::Image());
    ICO_GG = Gtk::manage(new Gtk::Image());
    ICO_NOVELL = Gtk::manage(new Gtk::Image());
    ICO_MYSPACE = Gtk::manage(new Gtk::Image());
    ICO_SILC = Gtk::manage(new Gtk::Image());
    ICO_MEANWHILE = Gtk::manage(new Gtk::Image());
    ICO_SIMPLE = Gtk::manage(new Gtk::Image());
    ICO_YAHOO = Gtk::manage(new Gtk::Image());
    ICO_SKYPE = Gtk::manage(new Gtk::Image());
    ICO_MXIT = Gtk::manage(new Gtk::Image());
    ICO_ZEPHYR = Gtk::manage(new Gtk::Image());
    ICO_TELEGRAM = Gtk::manage(new Gtk::Image());
    ICO_SLACK = Gtk::manage(new Gtk::Image());
    //chat roles
    ICO_CHRFOUNDER = Gtk::manage(new Gtk::Image());
    ICO_CHRHALFOP = Gtk::manage(new Gtk::Image());
    ICO_CHRNORMAL = Gtk::manage(new Gtk::Image());
    ICO_CHROP = Gtk::manage(new Gtk::Image());
    ICO_CHRVOICE = Gtk::manage(new Gtk::Image());

    createIcon(ICO_BIGICON, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "dxim.png");
    createIcon(ICO_SMALLICON, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "dximsmall.png");
    createIcon(ICO_ABOUTICON, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "dximabout.png");
    createIcon(ICO_IM, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "im.png");
    createIcon(ICO_IMNEWMSG, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "imnewm.png");
    createIcon(ICO_IMCOMPOSE, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "imcompose.png");
    createIcon(ICO_IMOFF, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "imoff.png");
    createIcon(ICO_CHAT, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "chat.png");
    createIcon(ICO_CHATNEWMSG, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "chatnewm.png");
    createIcon(ICO_FOLDER, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "folder.png");
    createIcon(ICO_FILE, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "page.png");
    createIcon(ICO_INFO, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "info.png");
    createIcon(ICO_EMAIL, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "email.png");
    createIcon(ICO_DOWN, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "arrow_down.png");
    createIcon(ICO_UP, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "arrow_up.png");
    createIcon(ICO_CANCEL, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "cancel.png");
    createIcon(ICO_FINISH, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "finish.png");
    //statuses
    createStatusIcons();
    createIcon(ICO_CONNECTING, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "connecting.png");
    //protocols
    createIcon(ICO_WLM, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "protocols" G_DIR_SEPARATOR_S "wlm.png");
    createIcon(ICO_XMPP, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "protocols" G_DIR_SEPARATOR_S "xmpp.png");
    createIcon(ICO_IRC, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "protocols" G_DIR_SEPARATOR_S "irc.png");
    createIcon(ICO_ICQ, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "protocols" G_DIR_SEPARATOR_S "icq.png");
    createIcon(ICO_AIM, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "protocols" G_DIR_SEPARATOR_S "aim.png");
    createIcon(ICO_BONJOUR, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "protocols" G_DIR_SEPARATOR_S "bonjour.png");
    createIcon(ICO_GG, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "protocols" G_DIR_SEPARATOR_S "gadu-gadu.png");
    createIcon(ICO_NOVELL, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "protocols" G_DIR_SEPARATOR_S "novell.png");
    createIcon(ICO_MYSPACE, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "protocols" G_DIR_SEPARATOR_S "myspace.png");
    createIcon(ICO_SILC, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "protocols" G_DIR_SEPARATOR_S "silc.png");
    createIcon(ICO_MEANWHILE, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "protocols" G_DIR_SEPARATOR_S "meanwhile.png");
    createIcon(ICO_SIMPLE, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "protocols" G_DIR_SEPARATOR_S "simple.png");
    createIcon(ICO_YAHOO, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "protocols" G_DIR_SEPARATOR_S "yahoo.png");
    createIcon(ICO_SKYPE, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "protocols" G_DIR_SEPARATOR_S "skype.png");
    createIcon(ICO_MXIT, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "protocols" G_DIR_SEPARATOR_S "mxit.png");
    createIcon(ICO_ZEPHYR, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "protocols" G_DIR_SEPARATOR_S "zephyr.png");
    createIcon(ICO_TELEGRAM, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "protocols" G_DIR_SEPARATOR_S "telegram.png");
    createIcon(ICO_SLACK, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "protocols" G_DIR_SEPARATOR_S "slack.png");
    //chat roles
    createRoleIcons();

    Glib::RefPtr<Gtk::IconFactory> factory = Gtk::IconFactory::create();
    createStockItem(factory, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "ft.png", "dxim-filetransfer", _("File _transfers"));
    createStockItem(factory, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "logs.png", "dxim-logs", _("_Log viewer"));
    createStockItem(factory, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "statuses" G_DIR_SEPARATOR_S "online.png", "dxim-online", _("Available"));
    createStockItem(factory, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "statuses" G_DIR_SEPARATOR_S "away.png", "dxim-away", _("Away"));
    createStockItem(factory, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "statuses" G_DIR_SEPARATOR_S "idle.png", "dxim-idle", _("Idle"));
    createStockItem(factory, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "statuses" G_DIR_SEPARATOR_S "dnd.png", "dxim-dnd", _("Busy"));
    createStockItem(factory, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "statuses" G_DIR_SEPARATOR_S "invisible.png", "dxim-invisible", _("Invisible"));
    createStockItem(factory, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "statuses" G_DIR_SEPARATOR_S "offline.png", "dxim-offline", _("Offline"));
    createStockItem(factory, DXIM_DATADIR G_DIR_SEPARATOR_S "icons" G_DIR_SEPARATOR_S "newm.png", "dxim-newm", "New message");
    factory->add_default();
}
