/*
 *      icons.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef ICONS_H
#define ICONS_H

#include <gtkmm.h>

Glib::RefPtr<Gdk::Pixbuf> createPixbuf(const Glib::ustring &path);
void createStatusIcons();
void createRoleIcons();
void makeIcons();

extern Gtk::Image *ICO_BIGICON;
extern Gtk::Image *ICO_SMALLICON;
extern Gtk::Image *ICO_ABOUTICON;
extern Gtk::Image *ICO_IM;
extern Gtk::Image *ICO_IMNEWMSG;
extern Gtk::Image *ICO_IMCOMPOSE;
extern Gtk::Image *ICO_IMOFF;
extern Gtk::Image *ICO_CHAT;
extern Gtk::Image *ICO_CHATNEWMSG;
extern Gtk::Image *ICO_FOLDER;
extern Gtk::Image *ICO_FILE;
extern Gtk::Image *ICO_INFO;
extern Gtk::Image *ICO_EMAIL;
extern Gtk::Image *ICO_DOWN;
extern Gtk::Image *ICO_UP;
extern Gtk::Image *ICO_CANCEL;
extern Gtk::Image *ICO_FINISH;
//statuses
extern Gtk::Image *ICO_AWAY;
extern Gtk::Image *ICO_INVISIBLE;
extern Gtk::Image *ICO_DND;
extern Gtk::Image *ICO_OFFLINE;
extern Gtk::Image *ICO_ONLINE;
extern Gtk::Image *ICO_IDLE;
extern Gtk::Image *ICO_CONNECTING;
//protocols
extern Gtk::Image *ICO_XMPP;
extern Gtk::Image *ICO_WLM;
extern Gtk::Image *ICO_IRC;
extern Gtk::Image *ICO_ICQ;
extern Gtk::Image *ICO_AIM;
extern Gtk::Image *ICO_BONJOUR;
extern Gtk::Image *ICO_GG;
extern Gtk::Image *ICO_NOVELL;
extern Gtk::Image *ICO_MYSPACE;
extern Gtk::Image *ICO_SILC;
extern Gtk::Image *ICO_MEANWHILE;
extern Gtk::Image *ICO_SIMPLE;
extern Gtk::Image *ICO_YAHOO;
extern Gtk::Image *ICO_SKYPE;
extern Gtk::Image *ICO_MXIT;
extern Gtk::Image *ICO_ZEPHYR;
extern Gtk::Image *ICO_TELEGRAM;
extern Gtk::Image *ICO_SLACK;
//chat roles
extern Gtk::Image *ICO_CHRFOUNDER;
extern Gtk::Image *ICO_CHRHALFOP;
extern Gtk::Image *ICO_CHRNORMAL;
extern Gtk::Image *ICO_CHROP;
extern Gtk::Image *ICO_CHRVOICE;


#endif  /* ICONS_H */

