/*
 *      imtabitem.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef IMTABITEM_H
#define IMTABITEM_H

#include "convtabitem.h"

class ImTabItem : public ConvTabItem {
public:
    ImTabItem(PURPLE::Conversation *conv, dxgCallbacks *cb, Gtk::Notebook *parent, ImageLabel *label);

    void removeHighligth();
private:
    Gtk::ScrolledWindow m_textscroll;
    dxgCallbacks *m_cb;
    ImageLabel *m_id;

    //slot start
    bool onTimeout();
    //purplemm
    void onNewMyMsg(PURPLE::Conversation *conv, Glib::ustring time, Glib::ustring msg, bool action, Glib::ustring messageID);
    void onMessageRecived(PURPLE::Conversation *conv, Glib::ustring messageID);
    void onNewIMMsg(PURPLE::Conversation *conv, Glib::ustring time, Glib::ustring sender, Glib::ustring msg, bool highlight, bool action);
    void onNewConvSystemMessage(PURPLE::Conversation *conv, Glib::ustring time, Glib::ustring msg);
    void onNewConvErrorMessage(PURPLE::Conversation *conv, Glib::ustring time, Glib::ustring msg);
    void onBuddySignedOn(PURPLE::Buddy buddy);
    void onBuddySignedOff(PURPLE::Buddy buddy);
    void onBuddyStatusChanged(PURPLE::Buddy buddy, PurpleStatusPrimitive status);
    void onBuddyTyping(PURPLE::Conversation *conv, bool typing);
    //slot end
    void loadCurrentLog();

};

#endif  /* IMTABITEM_H */

