/*
 *      msgtabitem.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef MSGTABITEM_H
#define MSGTABITEM_H

#include <gtkmm.h>
#include <purplemm.h>
#include "tabitem.h"

class MsgTabItem : public TabItem {
public:
    MsgTabItem(PurpleNotifyMsgType type, Glib::ustring id, Glib::ustring text, Glib::ustring okText, Glib::ustring url, Gtk::Notebook *parent, ImageLabel *label);
    MsgTabItem(Glib::ustring id, Glib::ustring okText, Gtk::Notebook *parent, ImageLabel *label);

    sigc::signal<void, int> signalMsgTabItemClosed;

    void clearMsgTab();
    Glib::ustring getID() const { return m_id; }
    void appendText(const Glib::ustring &text);
    void loadLog(const Glib::ustring &path);
private:
    Gtk::ScrolledWindow m_textscroll;
    Glib::ustring m_url;
    Gtk::Button *m_okButton;
    Glib::ustring m_id;

    //slot start
    void onOk();
    //slot end
    void appendLogLine(const Glib::ustring &line);
};

#endif  /* MSGTABITEM_H */

