/*
 *      tabbook.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef TABBOOK_H
#define TABBOOK_H

#include <gtkmm.h>
#include "callback/callback.h"

class ImTabItem;
class ChatTabItem;
class MsgTabItem;

class Tabbook : public Gtk::Notebook
{
public:
    Tabbook();

    ImTabItem* createImTab(PURPLE::Conversation *conv, dxgCallbacks *cb);
    ChatTabItem* createChatTab(PURPLE::Conversation *conv, dxgCallbacks *cb);
    MsgTabItem* createMsgTab(Gtk::Image *icon, PurpleNotifyMsgType type, Glib::ustring id, Glib::ustring title, Glib::ustring text, Glib::ustring okText, Glib::ustring url);
    MsgTabItem* createMsgTab(const Gtk::StockID &icon, Glib::ustring id, Glib::ustring title, Glib::ustring okText);
};
#endif
