/*
 *      dxcolor.h
 *
 *      Copyright 2014 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef DXCOLOR_H
#define DXCOLOR_H

#include <gtkmm.h>

class dxColor
{
public:
    dxColor();
    dxColor(const Glib::ustring&value);
#if GTKMM_MAJOR_VERSION == 2
    dxColor(Gdk::Color color);
#else
    dxColor(Gdk::RGBA color);
#endif
    
    bool operator==(const dxColor&) const;
    bool operator!=(const dxColor&) const;
    Glib::ustring to_string() const;
    bool set(const Glib::ustring& spec);
#if GTKMM_MAJOR_VERSION == 2
    Gdk::Color get_color() const { return m_color; }
#else
    Gdk::RGBA get_color() const { return m_color; }
#endif
    gushort get_red() const;
    gushort get_green() const;
    gushort get_blue() const;
    void set_red(gushort value);
    void set_green(gushort value);
    void set_blue(gushort value);
private:
#if GTKMM_MAJOR_VERSION == 2
    Gdk::Color m_color;
#else
    Gdk::RGBA m_color;
#endif
};
#endif /* DXCOLOR_H */
