/*
 *      imagelabel.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef IMAGELABEL_H
#define IMAGELABEL_H

#include <gtkmm.h>
#include "dxcolor.h"

class ImageLabel : public Gtk::HBox
{
public:
    ImageLabel();
    ImageLabel(const Glib::ustring &text);
    ImageLabel(const Glib::RefPtr<Gdk::Pixbuf> &icon, const Glib::ustring &text);
    ImageLabel(const Gtk::StockID &icon, const Glib::ustring &text);

    void setIcon(const Glib::RefPtr<Gdk::Pixbuf> &icon);
    void setText(const Glib::ustring &text);
    Glib::ustring getText() const { return m_text; }
    void setColor(const dxColor &color);
    void clearColor();
    bool isColored();
private:
    Glib::ustring m_text;
    Gtk::Image m_image;
    Gtk::Label m_label;
};
#endif /* IMAGELABEL_H */
