/*
 *      linklabel.h
 *
 *      Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef LINKLABEL_H
#define LINKLABEL_H

#include <gtkmm.h>
#include "dxcolor.h"

class LinkLabel : public Gtk::EventBox
{
public:
    LinkLabel();
    LinkLabel(const Glib::ustring &text);

    void setText(const Glib::ustring &text);
    Glib::ustring getText() const { return m_text; }
    void setColor(const dxColor &color);
    dxColor getColor() const { return m_color; }
private:
    Glib::ustring m_text;
    Gtk::Label m_label;
#if GTKMM_MAJOR_VERSION == 2
    Gdk::Cursor m_hand;
#else
    Glib::RefPtr<Gdk::Cursor> m_hand;
#endif
    dxColor m_color;
    
    void create();
    bool onEnterNotify(GdkEventCrossing *event);
    bool onClick(GdkEventButton *event);
};
#endif /* LINKLABEL_H */
