/*
 * soundmm.cpp
 *
 * Copyright 2011 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "purplemm.h"
#include "soundmm.h"

namespace PURPLE
{
#define CALLBACKS Purple::instance()->getCallbacks()

void Sound::init()
{
    purple_sound_set_ui_ops(&soundOps);
}

void Sound::uninit()
{
    purple_notify_set_ui_ops(NULL);
}

/* STATIC */

PurpleSoundUiOps Sound::soundOps =
{
    NULL,
    NULL,
    NULL,
    Sound::playSound,
    NULL,
    NULL,
    NULL,
    NULL
};

void Sound::playSound(PurpleSoundEventID event)
{
    if(event >= PURPLE_NUM_SOUNDS)
    {
        if(CALLBACKS) CALLBACKS->showError("Got request for unknown sound");
        return;
    }
    if(CALLBACKS) CALLBACKS->playSound(event);
}

} /* namespace PURPLE */

