/*
 * soundmm.h
 *
 * Copyright 2011 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef SOUNDMM_H
#define SOUNDMM_H

#include <purple.h>
#include "exportmm.h"

namespace PURPLE
{

/** This class represents a sound */
class PURPLEMM_EXPORT Sound
{
    static PurpleSoundUiOps soundOps;
    static void playSound(PurpleSoundEventID event);
public:
    /** Initialization of libpurple sound' stuffs. */
    static void init();
    /** Uninitialization of libpurple sound' stuffs. */
    static void uninit();
};

} /* namespace PURPLE */

#endif // SOUNDMM_H
