/*
 *      aboutdialog.cpp
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#include <QLabel>
#include <QDialogButtonBox>
#include <QVBoxLayout>
#include <QApplication>
#include "aboutdialog.h"
#include "config.h"
#include "i18n.h"

AboutDialog::AboutDialog(const QString &purplemm, const QString &libpurple, QWidget *parent) :
    QDialog(parent)
{
    QLabel *icon = new QLabel;
    icon->setPixmap(QPixmap(DXIM_DATADIR "/icons/dximabout.png"));
    icon->setAlignment(Qt::AlignCenter);
    QLabel *name = new QLabel;
    name->setText(QString("<big><b>dxim %2<br>(Qt toolkit)</b></big>").arg(qApp->applicationVersion()));
    name->setAlignment(Qt::AlignCenter);
    QDialogButtonBox *buttons = new QDialogButtonBox(QDialogButtonBox::Ok);
    connect(buttons, SIGNAL(accepted()), this, SLOT(accept()));
    QVBoxLayout *mainLayout = new QVBoxLayout;
    QLabel *link = new QLabel;
    link->setText("<a href=\"https://dxim.dxsolutions.org\">https://dxim.dxsolutions.org</a>");
    link->setAlignment(Qt::AlignCenter);
    link->setOpenExternalLinks(true);
    QLabel *fam = new QLabel;
    fam->setText(_("<small>Uses <a href=\"http://www.famfamfam.com/lab/icons/\">famfamfam icons</a></small>"));
    fam->setOpenExternalLinks(true);
    QLabel *license = new QLabel;
    license->setText(_("Released under the <a href=\"http://www.gnu.org/licenses/gpl.html\">GPL 3</a> license"));
    license->setOpenExternalLinks(true);
    mainLayout->addWidget(icon);
    mainLayout->addWidget(name);
    mainLayout->addWidget(new QLabel(_("Copyright (C) 2012~\nDavid Vachulka (arch_dvx@users.sourceforge.net)\nand others")));
    mainLayout->addWidget(license);
    mainLayout->addWidget(new QLabel(_("<small>Uses Qt %1</small>").arg(qVersion())));
    mainLayout->addWidget(new QLabel(_("<small>Uses purplemm %1</small>").arg(purplemm)));
    mainLayout->addWidget(new QLabel(_("<small>Uses libpurple %1</small>").arg(libpurple)));
    mainLayout->addWidget(fam);
    mainLayout->addWidget(link);
    mainLayout->addWidget(buttons);
    setLayout(mainLayout);
    setWindowTitle(_("About dxim"));
}
