/*
 *      accountdialog.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef ACCOUNTDIALOG_H
#define ACCOUNTDIALOG_H

#include <QDialog>
#include <QTreeWidget>
#include <QPushButton>
#include <purplemm.h>

class AccountDialog : public QDialog
{
    Q_OBJECT
public:
    explicit AccountDialog(PURPLE::Purple *purple, QWidget *parent = 0);
private slots:
    void slotEnableAccount();
    void slotAddAccount();
    void slotModifyAccount();
    void slotDeleteAccount();
    void slotCurrentChanged(QTreeWidgetItem *current);
private:
    PURPLE::Purple *m_purple;
    QTreeWidget *m_accountView;
    QPushButton *m_buttonDelete, *m_buttonModify, *m_buttonEnable;

    void updateTable();
};

#endif // ACCOUNTDIALOG_H
