/*
 *      chatdialog.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef CHATDIALOG_H
#define CHATDIALOG_H

#include <QDialog>
#include <QComboBox>
#include <QSpinBox>
#include <QLineEdit>
#include <QPushButton>
#include <QGridLayout>
#include <QCheckBox>
#include "defs.h"
#include "callback/callback.h"

class ChatDialog : public QDialog
{
    Q_OBJECT
public:
    //for create new PURPLE::Chat
    ChatDialog(PURPLE::Account account, QWidget *parent = 0);
    //for modify PURPLE::Chat
    ChatDialog(PURPLE::Chat chat, QWidget *parent = 0);
public slots:
    void accept();
private:
    QGridLayout *m_grid;
    QComboBox *m_groups;
    QLineEdit *m_alias;
    QCheckBox *m_autoJoin;
    PURPLE::Account m_account;
    PURPLE::Chat m_chat;
    bool m_modifing;
    QVector<QWidget*> m_fields;

    std::vector<PURPLE::Account::ChatEntry> fillChatEntryFields();
    void createWidgets();
};

#endif // CHATDIALOG_H
