/*
 *      chatjoindialog.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef CHATJOINDIALOG_H
#define CHATJOINDIALOG_H

#include <QDialog>
#include <QComboBox>
#include <QSpinBox>
#include <QLineEdit>
#include <QPushButton>
#include <QGridLayout>
#include <QLabel>
#include "defs.h"
#include "callback/callback.h"

class ChatJoinDialog : public QDialog
{
    Q_OBJECT
public:
    ChatJoinDialog(std::vector<PURPLE::Account> accounts, dxqCallbacks *cb, QWidget *parent = 0);
    ChatJoinDialog(PURPLE::Account account, dxqCallbacks *cb, QWidget *parent = 0);
public slots:
    void accept();
private slots:
    void slotIDs(int index);
    void slotRoomlistCreated(PURPLE::RoomList *rlist);
    void slotGetChatList();
    void slotRoomlistClosed(bool join, QString room);
private:
    QGridLayout *m_grid;
    QComboBox *m_IDs;
    QPushButton *m_buttonList;
    std::vector<PURPLE::Account> m_accounts;
    QVector<QLabel*> m_labels;
    QVector<QWidget*> m_fields;

    void createControls(dxqCallbacks *cb);
    void createChatEntryFields(std::vector<PURPLE::Account::ChatEntry> fields);
    std::vector<PURPLE::Account::ChatEntry> fillChatEntryFields();
};

#endif // CHATJOINDIALOG_H
