/*
 *      imdialog.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef IMDIALOG_H
#define IMDIALOG_H

#include <QDialog>
#include <QComboBox>
#include <QLineEdit>
#include <QCompleter>
#include "defs.h"

class ImDialog : public QDialog
{
    Q_OBJECT
public:
    ImDialog(std::vector<PURPLE::Account> accounts, QWidget *parent = 0);
    ImDialog(PURPLE::Account account, QWidget *parent = 0);

    void fillIMInfo(QString &ID, QString &protocol, QString &IMID, QString &IMnick);
    void fillIMInfo(QString &IMID, QString &IMnick);
private slots:
    void slotAccountChanged(int);
private:
    QComboBox *m_accountsList;
    QLineEdit *m_with;
    QCompleter *m_completer;
    std::vector<PURPLE::Account> m_accounts;

    void createControls();
};

#endif // IMDIALOG_H
