/*
 *      plugindialog.h
 *
 *      Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef PLUGINDIALOG_H
#define PLUGINDIALOG_H

#include <QDialog>
#include <QTreeWidget>
#include <QPushButton>
#include <QLabel>
#include <QGroupBox>
#include <purplemm.h>

class PluginDialog : public QDialog
{
    Q_OBJECT
public:
    explicit PluginDialog(PURPLE::Purple *purple, QWidget *parent = 0);
private slots:
    void accept();
    void slotEnablePlugin();
    void slotModifyPlugin();
    void slotCurrentChanged(QTreeWidgetItem *current);
private:
    PURPLE::Purple *m_purple;
    std::vector<PURPLE::Plugin> m_plugins;
    QTreeWidget *m_pluginView;
    QPushButton *m_buttonModify, *m_buttonEnable;
    QLabel *m_description, *m_summary, *m_version, *m_author, *m_path, *m_homepage;
    QGroupBox *m_details;

    void updateTable();
    void updateDetails();
};

#endif // PLUGINDIALOG_H
