/*
 *      plugineditordialog.h
 *
 *      Copyright 2013 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef PLUGINEDITORDIALOG_H
#define PLUGINEDITORDIALOG_H

#include <QDialog>
#include <QLabel>
#include <QLineEdit>
#include <QTabWidget>
#include <QCheckBox>
#include <QBoxLayout>
#include <QPushButton>
#include <QSpinBox>
#include <purplemm.h>

class PluginEditorDialog : public QDialog
{
    Q_OBJECT
public:
    /* Constructor for modifying plugin */
    PluginEditorDialog(PURPLE::Plugin plugin, QWidget *parent = 0);
private:
    PURPLE::Plugin m_plugin; //use for creating
    PURPLE::Plugin::Options m_options;
    QVector<QWidget*> m_optionsFields;

    void initializeEditor();
    int getIntlistValue(std::map<std::string, int> map, std::string key);
    void saveProtocolOptions();
private slots:
    void accept();
};

#endif // PLUGINEDITORDIALOG_H
