/*
 *      roomlistdialog.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef ROOMLISTDIALOG_H
#define ROOMLISTDIALOG_H

#include <QDialog>
#include <QTreeWidget>
#include <QPushButton>
#include <QLineEdit>
#include "defs.h"
#include "callback/callback.h"

class RoomListDialog : public QDialog
{
    Q_OBJECT
public:
    explicit RoomListDialog(PURPLE::RoomList *rlist, dxqCallbacks *cb, QWidget *parent = 0);
signals:
    void signalClosed(bool join, QString room);
public slots:
    void accept();
    void reject();
private slots:
    void slotRoomlistColumns(PURPLE::RoomList *rlist, QVector<QString> columns);
    void slotRoomlistAddRoom(PURPLE::RoomList *rlist, QVector<QString> fields);
    void slotRoomlistFinished(PURPLE::RoomList *rlist);
    void slotSearch();
private:
    QTreeWidget *m_roomView;
    QPushButton *m_selectButton;
    PURPLE::RoomList *m_rlist;
    bool m_finished;
    QLineEdit *m_search;
    QStringList m_rooms;
    int m_columns;
};

#endif // ROOMLISTDIALOG_H
