/*
 *      i18n.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef I18N_H
#define I18N_H

#include <QString>

#ifdef HAVE_SETLOCALE
#include <locale.h>
#endif

#if ENABLE_NLS
#include <libintl.h>
#define _(String) QString::fromUtf8(gettext (String))
#define gettext_noop(String) String
#define N_(String) gettext_noop (String)
#define _n(id1, id2, n) QString::fromUtf8(ngettext((const char*)id1, (const char*)id2, (unsigned long int)n))
#else
#define _(String) QString::fromUtf8(String)
#define N_(String) QString::fromUtf8(String)
#define _n(id1, id2, n) QString::fromUtf8((const char*)id2)
#endif

#endif
