/*
 *      logitem.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef LOGITEM_H
#define LOGITEM_H

#include <QStandardItem>
#include <QDateTime>
#include "defs.h"

class LogItem : public QStandardItem
{
public:
    enum LogItemType {
        Root = 0,
        Account,
        Conversation,
        Year,
        Month,
        File
    };

    enum UserRoles {
        LType = Qt::UserRole+2,
        LPath,
        LTime
    };

    LogItem(const QString &name, LogItemType type, const QString &path="");

    LogItemType getLogItemType();
    QString getPath();
    void setPath(const QString &path);
    void setTime(QDateTime time);
    QDateTime getTime();
    int disabledCount();
};

#endif // LOGITEM_H
