/*
 *      rosteritemmodel.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef ROSTERITEMMODEL_H
#define ROSTERITEMMODEL_H

#include <QStandardItemModel>
#include "rosteritem.h"

class RosterItemModel : public QStandardItemModel
{
public:
    RosterItemModel(QObject* parent);

    RosterItem* getRosterItem(RosterItem::RosterItemType type, const QString &ID, PURPLE::Account account);
    bool hasRosterItem(RosterItem::RosterItemType type, const QString &ID, PURPLE::Account account);
    void addRosterItem(RosterItem *parent, RosterItem *item);
    void removeRosterItem(RosterItem::RosterItemType type, const QString &ID, PURPLE::Account account);
    void removeAccountItem(const QString &account, const QString &protocol);
    void accountConnecting(PURPLE::Account account);
    void accountPresence(PURPLE::Account account);
    void buddySignedOn(PURPLE::Buddy buddy);
    void buddySignedOff(PURPLE::Buddy buddy);
    void buddyStatusChanged(PURPLE::Buddy buddy);
    void buddyIconChanged(PURPLE::Buddy buddy);
    void clear();
    void updateStatusIconTheme();
    void updateAccountsTooltip();
    void buddySizeHint();
private:
    RosterItem* getRosterItem(const QModelIndex &start, RosterItem::RosterItemType type, const QString &ID, PURPLE::Account account);
    bool hasRosterItem(const QModelIndex &start, RosterItem::RosterItemType type, const QString &ID, PURPLE::Account account);
};

#endif // ROSTERITEMMODEL_H
