/*
 *      rosterview.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef ROSTERVIEW_H
#define ROSTERVIEW_H

#include <QAction>
#include <QTreeView>
#include "defs.h"

class BuddyAction : public QAction
{
    Q_OBJECT
public:
    BuddyAction(const QString &text, QObject* parent, PURPLE::Buddy::BuddyMenuItem item);

    void runCallback();
private:
    PURPLE::Buddy::BuddyMenuItem m_item;
};

class RosterView : public QTreeView
{
    Q_OBJECT
public:
    explicit RosterView(PURPLE::Purple *purple, QWidget *parent);

    void updateTheme();
signals:
    void signalCloseAccount(PURPLE::Account account);
private slots:
    void slotRosterPopup(const QPoint &pos);
    void slotDoubleClicked(const QModelIndex& index);
    void slotBuddyCb();
    void slotBuddyIM();
    void slotBuddyInfo();
    void slotBuddySendFile();
    void slotAccountCb();
    void slotJoinChat();
    void slotAccountStatus();
    void slotAccountAddBuddy();
    void slotAccountAddChat();
    void slotAccountAddGroup();
    void slotModifyChat();
    void slotRemoveChat();
    void slotRenameBuddy();
    void slotMoveBuddy();
    void slotRemoveBuddy();
    void slotReconnectAccount();
    void slotEnableAccount();
    void slotAliasAccount();
    void slotAccountIM();
    void slotAccountChat();
    void slotConfigAccount();
    void slotBuddyLogs();
    void slotChatLogs();
    void slotAccountLogs();
private:
    PURPLE::Purple *m_purple;
    QWidget *m_parent;
};

#endif // ROSTERVIEW_H
