/*
 *      chatitem.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef CHATITEM_H
#define CHATITEM_H

#include <QStandardItem>
#include <QItemDelegate>
#include <QPainter>
#include "defs.h"

class ChatItem : public QStandardItem
{
public:
    enum UserRoles {
        Name = Qt::UserRole+2,
        RealName,
        Role
    };

    ChatItem(const QString &name, const QString &realName, PurpleConvChatBuddyFlags role);

    void setName(const QString &name);
    QString getName();
    void setRealName(const QString &realName);
    QString getRealName();
    void setChatRole(PurpleConvChatBuddyFlags role);
    PurpleConvChatBuddyFlags getChatRole();
    void updateRoleIconTheme();
private:
    void updateTip();
};

#endif // CHATITEM_H
