/*
 *      chatitemmodel.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef CHATITEMMODEL_H
#define CHATITEMMODEL_H

#include <QStandardItemModel>
#include "chatitem.h"

class ChatItemModel : public QStandardItemModel
{
public:
    ChatItemModel(QObject* parent);

    ChatItem* getChatItem(const QString &name);
    bool hasChatItem(const QString &name);
    void addChatItem(const QString &name, const QString &realName, PurpleConvChatBuddyFlags role);
    void removeChatItem(const QString &name);
    void updateItem(const QString &name, PURPLE::ChatBuddy buddy);
    void clear();
    void updateRoleIconTheme();
};

#endif // CHATITEMMODEL_H
