/*
 *      msgtabitem.h
 *
 *      Copyright 2012 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef MSGTABITEM_H
#define MSGTABITEM_H

#include <QWidget>
#include <QTextBrowser>

class MsgTabItem : public QWidget
{
    Q_OBJECT
public:
    explicit MsgTabItem(QPixmap icon, QString id, QString text, QString okText, QString url="", QWidget *parent = 0);
    MsgTabItem(QString id, QString okText, QString url="", QWidget *parent = 0);
    virtual ~MsgTabItem();

    void updateTheme();
    void insertText(const QString &text);
    QString getID() const { return m_id; }
    void showLog(const QString &path);
signals:
    void signalMsgTabClosed();
private slots:
    void slotOK();
private:
    QTextBrowser *m_edit;
    QString m_url, m_id;
    QColor stringToColor(QString style);
    void appendLogLine(const QString &line);
};

#endif // MSGTABITEM_H
