#define AppName "dxim"
#define AppVersion "1.00.svn"
#define AppPublisher "David Vachulka"
#define AppURL "http://dxim.dxsolutions.org/"
#define AppNameFox "dxim (FOX tookit)"
#define AppExeNameFox "dxim-fox.exe"
#define AppNameQt "dxim (Qt toolkit)"
#define AppExeNameQt "dxim-qt.exe"
#define AppNameGtkmm "dxim (Gtkmm toolkit)"
#define AppExeNameGtkmm "dxim-gtkmm.exe"

[Setup]
; NOTE: The value of AppId uniquely identifies this application.
; Do not use the same AppId value in installers for other applications.
; (To generate a new GUID, click Tools | Generate GUID inside the IDE.)
AppId={{1B608CEB-153A-4343-B473-C32CA1061492}
AppName={#AppName}
AppVersion={#AppVersion}
AppVerName={#AppName} {#AppVersion}
AppPublisher={#AppPublisher}
AppPublisherURL={#AppURL}
AppSupportURL={#AppURL}
AppUpdatesURL={#AppURL}
DefaultDirName={pf}\{#AppName}
DefaultGroupName={#AppName}
OutputBaseFilename={#AppName}-{#AppVersion}-setup
LicenseFile=COPYING
Compression=lzma
SolidCompression=yes

[Languages]
Name: "english"; MessagesFile: "compiler:Default.isl"
Name: "czech"; MessagesFile: "compiler:Languages\Czech.isl"

[Tasks]
Name: "desktopicon"; Description: "{cm:CreateDesktopIcon}"; GroupDescription: "{cm:AdditionalIcons}"; Flags: unchecked
Name: "quicklaunchicon"; Description: "{cm:CreateQuickLaunchIcon}"; GroupDescription: "{cm:AdditionalIcons}"; Flags: unchecked; OnlyBelowVersion: 0,6.1

[Files]
Source: "bin\*.*"; DestDir: "{app}\bin"; Flags: ignoreversion recursesubdirs
Source: "etc\*.*"; DestDir: "{app}\etc"; Flags: ignoreversion recursesubdirs
Source: "lib\*.*"; DestDir: "{app}\lib"; Flags: ignoreversion recursesubdirs
Source: "share\*.*"; DestDir: "{app}\share"; Flags: ignoreversion recursesubdirs
Source: "COPYING"; DestDir: "{app}"; Flags: ignoreversion
; NOTE: Don't use "Flags: ignoreversion" on any shared system files

[Icons]
Name: "{group}\{#AppNameFox}"; Filename: "{app}\bin\{#AppExeNameFox}"
Name: "{group}\{#AppNameQt}"; Filename: "{app}\bin\{#AppExeNameQt}
Name: "{group}\{#AppNameGtkmm}"; Filename: "{app}\bin\{#AppExeNameGtkmm}
Name: "{group}\{cm:ProgramOnTheWeb,{#AppName}}"; Filename: "{#AppURL}"
Name: "{group}\{cm:UninstallProgram,{#AppName}}"; Filename: "{uninstallexe}"
Name: "{commondesktop}\{#AppNameFox}"; Filename: "{app}\bin\{#AppExeNameFox}"; Tasks: desktopicon
Name: "{commondesktop}\{#AppNameQt}"; Filename: "{app}\bin\{#AppExeNameQt}"; Tasks: desktopicon
Name: "{commondesktop}\{#AppNameGtkmm}"; Filename: "{app}\bin\{#AppExeNameGtkmm}"; Tasks: desktopicon
Name: "{userappdata}\Microsoft\Internet Explorer\Quick Launch\{#AppNameFox}"; Filename: "{app}\bin\{#AppExeNameFox}"; Tasks: quicklaunchicon
Name: "{userappdata}\Microsoft\Internet Explorer\Quick Launch\{#AppNameQt}"; Filename: "{app}\bin\{#AppExeNameQt}"; Tasks: quicklaunchicon
Name: "{userappdata}\Microsoft\Internet Explorer\Quick Launch\{#AppNameGtkmm}"; Filename: "{app}\bin\{#AppExeNameGtkmm}"; Tasks: quicklaunchicon
